% this script was written by Charbel Assaf,
% the matrix were written by Andrey Pravdivtsev and Oleg 
% the main object is to fit EXSY data and to mesaure exchange rates
% by perfoming only one mixing time
% Error of the constant rate is calculated as eq 32 in the Ref https://pubs.acs.org/doi/epdf/10.1021/cr00104a002
clear all
close all
tic 

p             = LoadPath()                                                 ;




%%
%%%%%%%%%%%%%%%%%%%%% systems parameters %%%%%%%%%%%%%%%%%%%%%%%%%%
data_in       = load("Experimental_data\EXSY_Integrals.txt",'-ASCII')      ; % Load EXSY_Integrals data


data.dmix     = data_in(:,1)                                               ; % mixing time of each experiment
data.IS       = data_in(:,2)                                               ; % Integral of IS       or I free-free
data.ICsS2    = data_in(:,3)                                               ; % Integral of ICsS2     or I eq-eq
data.ICsS2S2  = data_in(:,4)                                               ; % Integral of ICsS2->S2 or I eq-free
data.IS2CsS2  = data_in(:,5)                                               ; % Integral of IS2->CsS2 or I free-eq


%%% n is the reference of the data in every list
n             = 1                                                          ; % Pyridine from 1,2,3,4,5   4AP 6,7,8,9,10    NAM 11,12,13,14,15    and the temperature for each one 280,283,288,293,298
dmix          = data.dmix    (n)                                           ; % mixing time in second
IS            = data.IS      (n)                                           ; % Integral of IS       or I free-free
ICsS2         = data.ICsS2   (n)                                           ; % Integral of ICsS2     or I eq-eq
ICsS2S2       = data.ICsS2S2 (n)                                           ; % Integral of ICsS2->S2 or I eq-free
IS2CsS2       = data.IS2CsS2 (n)                                           ; % Integral of IS2->CsS2 or I free-eq
Icross        = 0.5*(ICsS2S2 + IS2CsS2)                                    ; % Integral of Icross
errorIS       = 0.02*IS                                                    ; % Error of Ifree Integrals 2%
errorICsS2    = 0.02*ICsS2                                                 ; % Error of Ieq Integrals 2%
errorIcross   = 0.01*Icross                                                ; % Error of Icross Integrals 1%


         
            K       = 2*(IS + Icross)/(ICsS2 + Icross)                     ; % this section to calculate Kd
            c       = (2 + K)                                              ;
            aa      = K*ICsS2+2*IS+c*Icross                                ;
            bb      = K*ICsS2+2*IS-c*Icross                                ;
            kd      = (2*K/(c*dmix))*log(aa/bb)                            ;
            kaprime = kd/K                                                 ;
           
        
            Kf      = 2*(IS*1.0001 + Icross)/(ICsS2 + Icross)              ; % this section to help calculate error of Ifree
            c       = (2 + Kf)                                             ;
            aa      = Kf*ICsS2+2*IS*1.0001+c*Icross                        ;
            bb      = Kf*ICsS2+2*IS*1.0001-c*Icross                        ;
            kdf     = (2*Kf/(c*dmix))*log(aa/bb)                           ;
            
            Ke      = 2*(IS + Icross)/(ICsS2*1.0001 + Icross)              ; % this section to help calculate error of Ieq
            c       = (2 + Ke)                                             ;
            aa      = Ke*ICsS2*1.0001+2*IS+c*Icross                        ;
            bb      = Ke*ICsS2*1.0001+2*IS-c*Icross                        ;
            kde     = (2*Ke/(c*dmix))*log(aa/bb)                           ;
            
            Kcross  = 2*(IS + Icross*1.0001)/(ICsS2 + Icross*1.0001)       ; % this section to help calculate error of Icross
            c       = (2 + Kcross)                                         ;
            aa      = Kcross*ICsS2+2*IS+c*Icross*1.0001                    ;
            bb      = Kcross*ICsS2+2*IS-c*Icross*1.0001                    ;
            kdcross = (2*Kcross/(c*dmix))*log(aa/bb)                       ;
            
            dkfdIf  = (kdf - kd) / (IS*0.0001)                             ; % error of Ifree
            dkedIe  = (kde - kd) / (ICsS2*0.0001)                          ; % error of Ieq
            dkcrossdIcross = (kdcross - kd) / (Icross*0.0001)              ; % error of Icross
                  
            errorkd = sqrt(((dkfdIf)^2*(errorIS)^2) + ((dkedIe)^2*(errorICsS2)^2) + ((dkcrossdIcross)^2*(errorIcross)^2)); % error of kd
            
            fprintf("results: \n")
            fprintf("Model  has kd = %.2f ± %.4f s-1 ,ka' = %.2f s-1.mmol/L \n",kd,errorkd,kaprime)
            

toc 