close all
clear all
tic 
p              = LoadPath()                                                ;

%% %%%%%%%%%%%%% set parameters 

S0 = 40;   Ir0  = 4;         Rf = 1/10;  Rb = 1/2;  kd = 10                                                          ; % Initial constant 
ka = 1000 ;
xdata                         = logspace(log10(0.001),log10(10),100)'                                                 ;
data.r                        = zeros(size(xdata))                                                                    ; % Define third column zeros CsS     
Nt                            = length(xdata)                                                                         ;
xdata_fit                     = reshape(xdata*[1,1],2*Nt,1)                                                           ;

S    = Substrate_concentration(kd,ka,S0,Ir0)                                          
CsS2                          = S0-2*Ir0-S                       
CsS                           = Ir0-CsS2  
K    = S/CsS2

%Mb = 2*CsS2 ;   Mf = S;   Mr = CsS;
Mb = -2*CsS2 ;   Mf = 0;   Mr = 0;
% %%%%%%%%%%%%% 'CSS2↔CSS+S MatrixkaRf'                             
                                                                         %(x, S0, Ir0, Mb, Mf, Mr,Rf, kd, ka, Rb)
y0                          = SABRE_twosite_exchange_LmatrixkaRf(xdata_fit, S0, Ir0, Mb, Mr, Mf,Rf, kd, ka, Rb)       ;

%% %%%%%%%%%%%%%%%%%% 'CSS2↔S2 MatrixkaRf'  

K1 = S/Ir0 ;
                                                            %(kd,Rb, Rf, K, Mb, Mf,  x)
y01                         = SABRE_onesite_exchange_Lmatrix2(kd,Rb, Rf, K1, Mb, Mf, xdata_fit)                                      ;
            S                           = S0/(1+3/K)                                                                                ;
            S2                          = S/2                                                                                       ;
            CsS2                        = Ir0                                                                                       ;
            fprintf("[S] = %.2f mM, [CsS2] = %.2f  mM \n",S, CsS2)

%% %%%%%%%%%%%%%%%%% 'CSS2↔S'
                                                                  %(kd, Rb, Rf, K, Mb, Mf, x)
y02                         = SABRE_onesite_exchange_Lmatrix2kaprime(kd, Rb, Rf, K, Mb, Mf, xdata_fit) ;


figure("Color","white",'DefaultAxesFontSize',25,'Position',[1050 300 1000 900])

semilogx(xdata, y0(1:100), 'b',xdata, y0(101:end), 'r','LineWidth',5.2)                                               
hold on 
semilogx(xdata, y01(1:100), 'c:',xdata, y01(101:end), 'black:','LineWidth',3)                                                         
% hold on 
% semilogx(xdata, y02(1:100), 'b--',xdata, y02(101:end), 'r--','LineWidth',2)                                       
ylim([Mb 0.01])                                                                                                   
xlim([0.001 90])
legend('C_SS_2↔C_SS+S','C_SS_2↔C_SS+S', 'C_SS_2↔S_2', 'C_SS_2↔S_2','C_SS_2↔S','C_SS_2↔S')                                                                       
legend('boxoff')

%ylabel("M_Z/P (mM)") %% 
%xlabel("d_m_i_x (s)")
%title("3 Fitting Models")
%%
PAPER = [xdata,y0(1:100), y0(101:end),y01(1:100), y01(101:end)];%,y02(1:100), y02(101:end)
%csvwrite('B.csv',PAPER)
%saveas(gcf,'Fitting.png')


toc