% Load values from .txt 
% divid the spectrum into 6 sections and fit each one with Lorentzian Take certain value, fit them and then use the new values to normalize the
% spectrum 
% Line 28 : put the value of the repetitive tau 
clear all
close all 
tic
p = LoadPath()                                                             ;
%%%%%%%%


%% loading data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

data_in       = load('\\uni-kiel.de\files\rad\public\section\own_contributions\papers\2023_CA_AP_JCH\Data\Figure_S7_Coupling\20230712_CA_2_13C_Pyr_exp8_dc.txt','-ASCII');        

ppm           = data_in(:,1)                                               ;
real          = data_in(:,2)                                               ;
Imag          = data_in(:,3)                                               ;

%%% Define the ranges for each section %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sections      = {[-14.99, -14.955], [-15.59, -15.53], [-21.63, -21.56], [-24.11, -24.07], [-27.225, -27.165],  [-29.13, -29.06] };

% Create a matrix to store the data for all sections
num_points          = 0                                                    ;
for i = 1:length(sections)
    section_range   = sections{i}                                          ;
    x_section       = ppm                                                  ;
    real_section    = real                                                 ;
    Imag_section    = Imag                                                 ;                                                    
    
    % Select data points within the current section range
    section_mask    = (x_section >= section_range(1)) & (x_section <= section_range(2));
    x_section       = x_section(section_mask)                              ;
    real_section    = real_section(section_mask)                           ;
    Imag_section    = Imag_section(section_mask)                           ;
    
    num_points      = max(num_points, numel(x_section))                    ;
end

all_section_data    = NaN(num_points, 18)                                  ; % Matrix with 18 columns for all sections

% Collect the data for each section
for i = 1:length(sections)
    section_range = sections{i};
    x_section = ppm;
    real_section = real;
    Imag_section = Imag;
    
    % Select data points within the current section range
    section_mask = (x_section >= section_range(1)) & (x_section <= section_range(2));
    x_section = x_section(section_mask);
    real_section = real_section(section_mask);
    Imag_section = Imag_section(section_mask);
    
    % Store the data in the matrix
    all_section_data(1:numel(x_section), (i-1)*3+1) = x_section;
    all_section_data(1:numel(real_section), (i-1)*3+2) = real_section;
    all_section_data(1:numel(Imag_section), (i-1)*3+3) = Imag_section;
end

%csvwrite('\\uni-kiel.de\files\rad\public\section\own_contributions\papers\2023_CA_AP_JCH\Data\Figure_1_SABRE_Scheme\20230712_CA_2_13C_Pyr_2_9.ser_cutted.csv', all_section_data);
csv_filename = '\\uni-kiel.de\files\rad\public\section\own_contributions\papers\2023_CA_AP_JCH\Data\Figure_S7_Coupling\20230712_CA_2_13C_Pyr_exp8_dc_cutted.csv';

% Save the matrix to the CSV file
writematrix(all_section_data, csv_filename);


toc