clear all
close all 
tic
p = LoadPath()                                                             ;


%%
%%%%%%%%%% Load all data and conbine them %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Folder       = "P:\user_permanent\Charbel_Assaf\0_NMR_Data\1_NMR400\20230907_1_13C_Pyr_6\Adjusted\"   ;

File         = "20230907_1_13C_pyr_6_exp222_-27.2_(1)_267K_adjusted.csv"    ;
%Files{2}         = "20230829_1_13C_pyr_5_exp206_-29.1_(1)_261K_adjusted.csv"  ;
%Files{3}         = "20230829_1_13C_pyr_5_exp306_-29.1_(1)_267K_adjusted.csv"  ;
%Files{4}         = "20230829_1_13C_pyr_5_exp22_-27.2_(1)_256K_adjusted.csv"   ;
%Files{5}         = "20230829_1_13C_pyr_5_exp208_-27.2_(1)_261K_adjusted.csv"  ;
%Files{6}         = "20230829_1_13C_pyr_5_exp308_-27.2_(1)_267K_adjusted.csv"  ;

[xdata,ydata]  = loaddata(Folder,File)                                     ;
xdata          = xdata/1e3                                                 ;
%%
%%%%%%%%%%%%%% Fitting all combined data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial parameter guesses
initial_params = [5,1, 5]                                                  ;

%%%%%%%%%%%%%% Define the fitting function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fitting_function      = @(b, x)SinusDamp(b(1),b(2),b(3),x)                 ;


%%%%%%%%%%%%%% Perform the fitting using nlinfit %%%%%%%%%%%%%%%%%%%%%%%%%%
[beta1,RR,Jacob,CovB] = nlinfit(xdata, ydata, fitting_function, initial_params);

ysim                  = fitting_function(beta1,xdata)                      ;
SE                    = sqrt(diag(CovB))                                   ;

%%%%%%%%%%%%%%%%%%% Display the fitted parameters %%%%%%%%%%%%%%%%%%%%%%%%%
A = beta1(1)                                                               ;
J = beta1(2)                                                               ;
R = beta1(3)                                                               ;

disp('Fitted Parameters:')                                                 ;
fprintf('A = %.3f ± %.3f Hz \n\r',[A,SE(1)])                               ;
fprintf('J = %.3f ± %.3f Hz \n\r',[J,SE(2)])                               ;
fprintf('R = %.3f ± %.3f Hz \n\r',[R,SE(3)])                               ;

%%%%%%%%%%%%%%%%%% Plotting %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plotNkinetics_loc(1,xdata,ydata,xdata,ysim)                                ;


toc
%%
%%%%%%%%%%%%%%%%%%Functions%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [xdata, ydata] = loaddata(Folder,File) 

              loaddata  = load(Folder+File)                                ;
              xdata     = loaddata(:,1)                                    ;
              ydata     = loaddata(:,2)                                    ;

end
%%

function RMSD  = plotNkinetics_loc(N,x,y,xsim,ysim)
            y  = reshape(y,length(x),N)                                    ;
          ysim = reshape(ysim,length(x),N)                                 ;
    figure("Color","white")
    for k = 1:N
        subplot(N,1,k)                                                     ;
        plot(x,y(:,k),"LineWidth",2,"Marker","o")
        hold on
        plot(xsim,ysim(:,k),"LineWidth",2,"Marker","o")                    ;
        hold off
    
        xlabel("𝜏_2 (s)")
        ylabel("Integrals (norm.)")
        axis([0,x(end)+0.2,-1.1,1.1])
        RMSD = rms(y(:,k)-ysim(:,k))                                       ;
        legend({"exp","sim"})
        title(sprintf("RMSD = %.4f",RMSD))                                 ;
    end
end