%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(6);
ex=Load_SABRE_System(System);

ex.Folder="out\SLIC_SHEATH_SABRE_"+System+"_vrf_v1.mat";
%% change these parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
frq_offset = linspace(-30,30,31); % [Hz] offset from X spin resonance
% field to v1 conversion for 13C
v1=0.25*[2.1,4.4,6.7]*1e-6*(ex.Ss.gamma{end}/(2*pi));
%v1=(0:10)*1e-6*(ex.Ss.gamma{end}/(2*pi));
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH= 1;                              % pH2 fraction (1 - 100)%
%ex.Kd =10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa =ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd =5;                             % [s^-1] dissociation rate for exC
%% ideal ADAPT parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.B0 = 120*1e-6;                               % observation magnetic field [T]
ex.timeRFv = [60];% linspace(0,100,2);          % X nuclei RF pulse time [s]
ex.offsetv = frq_offset; % [Hz] offset from X spin resonance
% rf on 13C
ex.v1v = v1/ex.Ss.g_gh{end};     % in [Hz] for 1H gamma!
ex.vrfv= -(1+ex.ppmC(end))*ex.Sc.gamma{end}*ex.B0/(2*pi)+ex.offsetv; % resonancing frequency
% rf on 1H
%ex.v1v = linspace(0,60,200)/ex.Ss.g_gh{1};     % in [Hz] for 1H gamma!
%ex.vrfv= -(1+ex.ppmC(1))*ex.Sc.gamma{1}*ex.B0/(2*pi)+ex.offsetv; % resonancing frequency
ex.prebubble = 10;

%% exC calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Yout = sabre_exC_ULF_SLIC(ex);
%Yout = sabre_MOD2_ULF_SLIC_Q(ex);
plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.c,ex,ex.show_c,ex.SOcStr,"Polarization")
plot_all_ULF_SLIC_SABRE(System,Yout.c,ex,ex.show_c);


%% MOD2 calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Yout = sabre_MOD2_ULF_SLIC(ex);
%Yout = sabre_MOD2_ULF_SLIC_Q(ex);
% % plot 1D
% display("[Substrate]/[Catalyst] = "+num2str(Yout.SABRE.fs/Yout.SABRE.fc));
% for k=1:length(ex.show_s)
%     Yout.total{k}=(Yout.s{ex.show_s(k)}*Yout.SABRE.fs+Yout.c{ex.show_c(k)}*Yout.SABRE.fc)/(Yout.SABRE.fs+Yout.SABRE.fc);        
%     ex.SOallStr{k}=ex.SOcStr{ex.show_c(k)};
%     ex.SOcStr{ex.show_c(k)}
%     ex.SOsStr{ex.show_s(k)}
% end
% ex.show_all=1:length(ex.show_s);
% plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.total,ex,ex.show_all,ex.SOallStr,"(P_f*[F]+P_c*[C])/([F]+[C])")
%% plot 2D
%plot_all_ULF_SLIC_SABRE(System,Yout.s,ex,ex.show_s);
%plot_all_ULF_SLIC_SABRE(System,Yout.total,ex,ex.show_all);


%% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data.System=System;
data.Yout=Yout;
data.ex=ex;
save(ex.Folder,'data');

%% %%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
