%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(1);% 5 - "HH-C"; 9 = "HH-1C-Pyruvate"; 10 = "HH-2C-Pyruvate"; 11 = "HH-2C-Pyruvate[2]"
ex=Load_SABRE_System(System);

ex.Folder="out\SABRESHEATH_";
ex.Model = "MOD2" % exC or MOD2;
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH=1;                              % pH2 fraction (1 - 100)%
ex.Kd = 25;                             % [s^-1] dissociation rate for exC
ex.Wa =ex.Kd/10;                       % [s^-1] association rate for MOD2
ex.Bv=[100,150,200,320]*1e-9;   % delay/storage external magnetic field, T
%ex.Bv=linspace(10,1000,10)*1e-9;   % delay/storage external magnetic field, T
%% SABRE magnetic field profile %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% simulations with exC or MOD2 SABRE models %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.tv=logspace(log10(0.001),log10(0.5),100);   % delay/storage external magnetic field, T
switch ex.Model
    %case "exC"  
    %    ex.Yout = sabre_exC_tB(ex);
    case "MOD2"
        ex.Yout = sabre_MOD2_tB(ex);
end

%% plot after SABRE simulation
switch ex.Model
    % case "exC"
    %     figure("Color","white")
    %     plot(ex.Bv*1e9,ex.Yout.c{ex.show_c(1)}*100,'b',"LineWidth",2);
    %     %semilogx(ex.Bv,ex.Yout.c{ex.show_c(1)}*100,'b',"LineWidth",2);
    %     hold on
    %     plot(ex.Bv*1e9,ex.Yout.c{ex.show_c(2)}*100,'r',"LineWidth",2);
    %     plot(ex.Bv*1e9,ex.Yout.c{ex.show_c(3)}*100,'r',"LineWidth",2);
    %     %semilogx(ex.Bv,ex.Yout.c{ex.show_c(2)}*100,'r',"LineWidth",2);
    %     legend(ex.SOcStr(ex.show_c(1:3)));
    %     axis([0,1000,-5,20]);
    %     xlabel("B (nT)");
    %     ylabel("Polarization (%)");
    %     title("SABRE SHEATH with tb = "+num2str(ex.tv,3)+"s, free substrate");
    case "MOD2"
        figure("Color","white")
        semilogx(ex.Bv,ex.Yout.s{ex.show_s(1)}*100,'b',"LineWidth",2);
        %hold on
        %semilogx(ex.Bv,ex.Yout.s{ex.show_s(2)}*100,'r',"LineWidth",2);        
        legend(ex.SOsStr(ex.show_s(1)));
        xlabel("B (T)");
        ylabel("Polarization (%)");
        title("SABRE SHEATH with tb = "+num2str(ex.tv,3)+"s, free substrate");
        display("[Substrate]/[Catalyst] = "+num2str(ex.Yout.SABRE.fs/ex.Yout.SABRE.fc));
end
%% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save(ex.Folder+System+"_B_Kd"+num2str(ex.Kd)+ex.Model+".mat","ex");
%%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
