%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();

S = SpinOperators(2);% product operator
p=1/sqrt(2);
QZ2S = [+1  0 0  0;
         0  p p  0;
         0 -p p  0;
         0  0 0 +1];

T=sym("T","positive");
QZ2E = [+1  0       0      0;
         0  cos(T)  sin(T) 0;
         0 -sin(T)  cos(T) 0;
         0  0       0     +1];

    
r=DensityMatrix(S.U);

disp("S1x");
r.val=S.x{1};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S2x");
r.val=S.x{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1x+S2x");
r.val=S.x{1}+S.x{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1x-S2x");
r.val=S.x{1}-S.x{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)
%%
disp("S1y/i");
r.val=imag(S.y{1});
DisplayDensityMatrix(r,S,QZ2S,QZ2E)
%%
disp("S2y/i");
r.val=imag(S.y{2});
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("(S1y+S2y)/i");
r.val=imag(S.y{1}+S.y{2});
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("(S1y-S2y)/i");
r.val=imag(S.y{1}-S.y{2});
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1z");
r.val=S.z{1};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S2z");
r.val=S.z{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1z+S2z");
r.val=S.z{1}+S.z{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1z-S2z");
r.val=S.z{1}-S.z{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1+");
r.val=1*S.x{1}+1i*S.y{1};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)


disp("S2+");
r.val=1*S.x{2}+1i*S.y{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1+  +  S2+");
r.val=S.x{1}+1i*S.y{1}+S.x{2}+1i*S.y{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1-");
r.val=1*S.x{1}-1i*S.y{1};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S2-");
r.val=1*S.x{2}-1i*S.y{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1-  +  S2-");
r.val=S.x{1}-1i*S.y{1}+S.x{2}-1i*S.y{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("T+ S");
rST = [0 0.5 0 0;
       0.5 0 0 0;
       0 0   0 0;
       0 0   0 0];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("T- S");
rST = [0 0 0 0;
       0 0 0 0.5;
       0 0 0 0;
       0 0.5 0 0];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("T+");
rST = [1 0 0 0;
       0 0 0 0;
       0 0 0 0;
       0 0 0 0];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("T0");
rST = [0 0 0 0;
       0 0 0 0;
       0 0 1 0;
       0 0 0 0];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S");
rST = [0 0 0 0;
       0 1 0 0;
       0 0 0 0;
       0 0 0 0];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("T-");
rST = [0 0 0 0;
       0 0 0 0;
       0 0 0 0;
       0 0 0 1];
r.val=QZ2S*rST/QZ2S;
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1zS2z");
r.val=S.z{1}*S.z{2};
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("ZQx");
r.val = [0 0   0   0;
         0 0   0.5 0;
         0 0.5 0   0;
         0 0   0   0];
DisplayDensityMatrix(r,S,QZ2S,QZ2E)
%%
disp("ZQy/i");
r.val = imag([0      0       0 0;
              0      0 -1i*0.5 0;
              0 1i*0.5       0 0;
              0      0       0 0]);
DisplayDensityMatrix(r,S,QZ2S,QZ2E)
%%
disp("DQx");
r.val = [0 0 0 0.5;
       0 0 0 0;
       0 0 0 0;
       0.5 0 0 0];
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("DQy/i");
r.val = imag([0 0 0 -1i*0.5;
       0 0 0 0;
       0 0 0 0;
       1i*0.5 0 0 0]);
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

disp("S1S2");
r.val=(S.x{1}*S.x{2}+S.y{1}*S.y{2}+S.z{1}*S.z{2});
DisplayDensityMatrix(r,S,QZ2S,QZ2E)

%% evolution of the first spin X magnetization
disp("S1x");
I1x=simplify(QZ2E\full(S.x{1})*QZ2E)
I1y=simplify(QZ2E\full(S.y{1})*QZ2E)
I1z=simplify(QZ2E\full(S.z{1})*QZ2E)
I2x=simplify(QZ2E\full(S.x{2})*QZ2E)
I2y=simplify(QZ2E\full(S.y{2})*QZ2E)
I2z=simplify(QZ2E\full(S.z{2})*QZ2E)
ZQx=simplify(QZ2E\full(S.x{1}*S.x{2}+S.y{1}*S.y{2})*QZ2E)
ZQy=simplify(QZ2E\full(S.y{1}*S.x{2}-S.x{1}*S.y{2})*QZ2E)
DQx=simplify(QZ2E\full(S.x{1}*S.x{2}-S.y{1}*S.y{2})*QZ2E)
DQy=simplify(QZ2E\full(S.y{1}*S.x{2}+S.x{1}*S.y{2})*QZ2E)
I1x2z=simplify(QZ2E\full(S.x{1}*S.z{2})*QZ2E)
I1y2z=simplify(QZ2E\full(S.y{1}*S.z{2})*QZ2E)
I1z2x=simplify(QZ2E\full(S.x{2}*S.z{1})*QZ2E)
I1z2y=simplify(QZ2E\full(S.y{2}*S.z{1})*QZ2E)


U=eye(4);
w21 = sym("w21","real");
w31 = sym("w31","real");
w42 = sym("w42","real");
w43 = sym("w43","real");

rI1x =     [                    0, -exp(1i*w21)*sin(T)/2,   exp(1i*w31)*cos(T)/2,        0;
            -exp(-1i*w21)*sin(T)/2,                    0,                       0,  exp(1i*w42)*cos(T)/2 ;
             exp(-1i*w31)*cos(T)/2,                    0,                       0,  exp(1i*w43)*sin(T)/2 ;
                                0, exp(-1i*w42)*cos(T)/2,  exp(-1i*w43)*sin(T)/2,        0];


A1x=Amplitude(rI1x,I1x) %1
A1y=Amplitude(rI1x,I1y) %2
A1z=Amplitude(rI1x,I1z) %3
A2x=Amplitude(rI1x,I2x) %4       
A2y=Amplitude(rI1x,I2y) %5
A2z=Amplitude(rI1x,I2z) %6
A1z2z=Amplitude(rI1x,I1z*I2z) %7
AZQx=Amplitude(rI1x,ZQx) %8
AZQy=Amplitude(rI1x,ZQy) %9
ADQx=Amplitude(rI1x,DQx) %10
ADQy=Amplitude(rI1x,DQy) %11
AU=Amplitude(rI1x,U) %12
A1x2z=Amplitude(rI1x,I1x2z) %13
A1y2z=Amplitude(rI1x,I1y2z) %14
A1z2x=Amplitude(rI1x,I1z2x) %13
A1z2y=Amplitude(rI1x,I1z2y) %14
%%
simplify(A1x-1/2*((cos(w42)+cos(w31))*cos(T)^2+(cos(w21)+cos(w43))*sin(T)^2))
simplify(A1y  +1/2*((sin(w42)+sin(w31))*cos(T)^2+(sin(w21)+sin(w43))*sin(T)^2))
simplify(A2x-1/4*((cos(w31)-cos(w42)+cos(w43)-cos(w21))*sin(2*T)))
simplify(A2y+1/4*((sin(w31)-sin(w42)+sin(w43)-sin(w21))*sin(2*T)))
simplify(A1x2z-((cos(w31)-cos(w42))*cos(T)^2+(-cos(w43)+cos(w21))*sin(T)^2))
simplify(A1y2z+((sin(w31)-sin(w42))*cos(T)^2+(-sin(w43)+sin(w21))*sin(T)^2))
simplify(A1z2x-1/2*((cos(w31)+cos(w42)-cos(w43)-cos(w21))*sin(2*T)))
simplify(A1z2y+1/2*((sin(w31)+sin(w42)-sin(w43)-sin(w21))*sin(2*T)))

simplify(rI1x-(A1x*I1x+A1y*I1y+A2x*I2x+A2y*I2y+A1x2z*I1x2z+A1y2z*I1y2z+A1z2x*I1z2x+A1z2y*I1z2y))
%% copy values for S1x case:
x1A1x=1/2*((cos(w42)+cos(w31))*cos(T)^2+(cos(w21)+cos(w43))*sin(T)^2);
x1A1y=-1/2*((sin(w42)+sin(w31))*cos(T)^2+(sin(w21)+sin(w43))*sin(T)^2);
x1A2x=+1/4*((cos(w31)-cos(w42)+cos(w43)-cos(w21))*sin(2*T));
x1A2y=-1/4*((sin(w31)-sin(w42)+sin(w43)-sin(w21))*sin(2*T));
x1A1x2z=+((cos(w31)-cos(w42))*cos(T)^2+(-cos(w43)+cos(w21))*sin(T)^2);
x1A1y2z=-((sin(w31)-sin(w42))*cos(T)^2+(-sin(w43)+sin(w21))*sin(T)^2);
x1A1z2x=+1/2*((cos(w31)+cos(w42)-cos(w43)-cos(w21))*sin(2*T));
x1A1z2y=-1/2*((sin(w31)+sin(w42)-sin(w43)-sin(w21))*sin(2*T));
%%
%% evolution of the SECOND spin X magnetization
disp("I2x");

U=eye(4);
w21 = sym("w21","real");
w31 = sym("w31","real");
w42 = sym("w42","real");
w43 = sym("w43","real");

rI2x = [                    0, exp(1i*w21)*cos(T)/2,   exp(1i*w31)*sin(T)/2,        0;
        exp(-1i*w21)*cos(T)/2,                    0,                       0, -exp(1i*w42)*sin(T)/2 ;
        exp(-1i*w31)*sin(T)/2,                    0,                       0, exp(1i*w43)*cos(T)/2 ;
                            0, -exp(-1i*w42)*sin(T)/2,  exp(-1i*w43)*cos(T)/2,        0];
A1x=Amplitude(rI2x,I1x) %1
A1y=Amplitude(rI2x,I1y) %2
A1z=Amplitude(rI2x,I1z) %3
A2x=Amplitude(rI2x,I2x) %4       
A2y=Amplitude(rI2x,I2y) %5
A2z=Amplitude(rI2x,I2z) %6
A1z2z=Amplitude(rI2x,I1z*I2z) %7
AZQx=Amplitude(rI2x,ZQx) %8
AZQy=Amplitude(rI2x,ZQy) %9
ADQx=Amplitude(rI2x,DQx) %10
ADQy=Amplitude(rI2x,DQy) %11
AU=Amplitude(rI2x,U) %12
A1x2z=Amplitude(rI2x,I1x2z) %13
A1y2z=Amplitude(rI2x,I1y2z) %14
A1z2x=Amplitude(rI2x,I1z2x) %13
A1z2y=Amplitude(rI2x,I1z2y) %14
%
simplify(A1x-1/4*((cos(w31)-cos(w42)+cos(w43)-cos(w21))*sin(2*T)))
simplify(A1y+1/4*((sin(w31)-sin(w42)+sin(w43)-sin(w21))*sin(2*T)))
simplify(A2x-1/2*((cos(w31)+cos(w42))*sin(T)^2+(cos(w43)+cos(w21))*cos(T)^2))
simplify(A2y+1/2*((sin(w31)+sin(w42))*sin(T)^2+(sin(w43)+sin(w21))*cos(T)^2))
simplify(A1x2z-1/2*((cos(w31)+cos(w42)-cos(w43)-cos(w21))*sin(2*T)))
simplify(A1y2z+1/2*((sin(w31)+sin(w42)-sin(w43)-sin(w21))*sin(2*T)))
simplify(A1z2x-((cos(w31)-cos(w42))*sin(T)^2+(-cos(w43)+cos(w21))*cos(T)^2))
simplify(A1z2y+((sin(w31)-sin(w42))*sin(T)^2+(-sin(w43)+sin(w21))*cos(T)^2))
%
x2A1x=1/4*((cos(w31)-cos(w42)+cos(w43)-cos(w21))*sin(2*T));
x2A1y=-1/4*((sin(w31)-sin(w42)+sin(w43)-sin(w21))*sin(2*T));
x2A2x=1/2*((cos(w31)+cos(w42))*sin(T)^2+(cos(w43)+cos(w21))*cos(T)^2);
x2A2y=-1/2*((sin(w31)+sin(w42))*sin(T)^2+(sin(w43)+sin(w21))*cos(T)^2);
x2A1x2z=1/2*((cos(w31)+cos(w42)-cos(w43)-cos(w21))*sin(2*T));
x2A1y2z=-1/2*((sin(w31)+sin(w42)-sin(w43)-sin(w21))*sin(2*T));
x2A1z2x=((cos(w31)-cos(w42))*sin(T)^2+(-cos(w43)+cos(w21))*cos(T)^2);
x2A1z2y=-((sin(w31)-sin(w42))*sin(T)^2+(-sin(w43)+sin(w21))*cos(T)^2);
%
simplify(rI2x-(A1x*I1x+A1y*I1y+A2x*I2x+A2y*I2y+A1x2z*I1x2z+A1y2z*I1y2z+A1z2x*I1z2x+A1z2y*I1z2y))
%%

%% evolution of the first spin Y magnetization
disp("S1y");

rI1y =  1i*[                    0,  exp(1i*w21)*sin(T)/2,   -exp(1i*w31)*cos(T)/2,        0;
            -exp(-1i*w21)*sin(T)/2,                    0,                       0,  -exp(1i*w42)*cos(T)/2 ;
             exp(-1i*w31)*cos(T)/2,                    0,                       0,  -exp(1i*w43)*sin(T)/2 ;
                                0, exp(-1i*w42)*cos(T)/2,   exp(-1i*w43)*sin(T)/2,        0];

A1x=Amplitude(rI1y,I1x) %1
A1y=Amplitude(rI1y,I1y) %2
A1z=Amplitude(rI1y,I1z) %3
A2x=Amplitude(rI1y,I2x) %4       
A2y=Amplitude(rI1y,I2y) %5
A2z=Amplitude(rI1y,I2z) %6
A1z2z=Amplitude(rI1y,I1z*I2z) %7
AZQx=Amplitude(rI1y,ZQx) %8
AZQy=Amplitude(rI1y,ZQy) %9
ADQx=Amplitude(rI1y,DQx) %10
ADQy=Amplitude(rI1y,DQy) %11
AU=Amplitude(rI1y,U) %12
A1x2z=Amplitude(rI1y,I1x2z) %13
A1y2z=Amplitude(rI1y,I1y2z) %14
A1z2x=Amplitude(rI1y,I1z2x) %13
A1z2y=Amplitude(rI1y,I1z2y) %14

% compare with values from S1x case:
%simplify(A1x+x1A1y)
%simplify(A1y-x1A1x)
%simplify(A2x+x1A2y)
%simplify(A2y-x1A2x)
%simplify(A1x2z+x1A1y2z)
%simplify(A1y2z-x1A1x2z)
%simplify(A1z2x+x1A1z2y)
%simplify(A1z2y-x1A1z2x)

simplify(rI1y-(A1x*I1x+A1y*I1y+A2x*I2x+A2y*I2y+A1x2z*I1x2z+A1y2z*I1y2z+A1z2x*I1z2x+A1z2y*I1z2y))


%% evolution of the SECOND spin Y magnetization
disp("I2y");

U=eye(4);
w21 = sym("w21","real");
w31 = sym("w31","real");
w42 = sym("w42","real");
w43 = sym("w43","real");

rI2y =1i*[                    0, -exp(1i*w21)*cos(T)/2, -exp(1i*w31)*sin(T)/2,        0;
          exp(-1i*w21)*cos(T)/2,                    0,                       0, exp(1i*w42)*sin(T)/2 ;
          exp(-1i*w31)*sin(T)/2,                    0,                       0, -exp(1i*w43)*cos(T)/2 ;
                              0, -exp(-1i*w42)*sin(T)/2, exp(-1i*w43)*cos(T)/2,        0];
A1x=Amplitude(rI2y,I1x) %1
A1y=Amplitude(rI2y,I1y) %2
A1z=Amplitude(rI2y,I1z) %3
A2x=Amplitude(rI2y,I2x) %4       
A2y=Amplitude(rI2y,I2y) %5
A2z=Amplitude(rI2y,I2z) %6
A1z2z=Amplitude(rI2y,I1z*I1z) %7
AZQx=Amplitude(rI2y,ZQx) %8
AZQy=Amplitude(rI2y,ZQy) %9
ADQx=Amplitude(rI2y,DQx) %10
ADQy=Amplitude(rI2y,DQy) %11
AU=Amplitude(rI2y,U) %12
A1x2z=Amplitude(rI2y,I1x2z) %13
A1y2z=Amplitude(rI2y,I1y2z) %14
A1z2x=Amplitude(rI2y,I1z2x) %13
A1z2y=Amplitude(rI2y,I1z2y) %14
%%
% compare with values from S1x case:
%simplify(A1x+x2A1y)
%simplify(A1y-x2A1x)
%simplify(A2x+x2A2y)
%simplify(A2y-x2A2x)
%simplify(A1x2z+x2A1y2z)
%simplify(A1y2z-x2A1x2z)
%simplify(A1z2x+x2A1z2y)
%simplify(A1z2y-x2A1z2x)
%simplify(rI2y-(A1x*I1x+A1y*I1y+A2x*I2x+A2y*I2y+A1x2z*I1x2z+A1y2z*I1y2z+A1z2x*I1z2x+A1z2y*I1z2y))
%%




%% evolution of the first spin Y magnetization
disp("S1z");

rI1z =  1/2*[                   1,                     0,                       0,        0;
                                0,              cos(2*T),    exp(1i*w21)*sin(2*T),        0;
                                0, exp(-1i*w21)*sin(2*T),               -cos(2*T),        0;
                                0,                     0,                       0,       -1];

A1x=Amplitude(rI1z,I1x) %1
A1y=Amplitude(rI1z,I1y) %2
A1z=Amplitude(rI1z,I1z) %3
A2x=Amplitude(rI1z,I2x) %4       
A2y=Amplitude(rI1z,I2y) %5
A2z=Amplitude(rI1z,I2z) %6
A1z2z=Amplitude(rI1z,I1z*I2z) %7
AZQx=Amplitude(rI1z,ZQx) %8
AZQy=Amplitude(rI1z,ZQy) %9
ADQx=Amplitude(rI1z,DQx) %10
ADQy=Amplitude(rI1z,DQy) %11
AU=Amplitude(rI1z,U) %12
A1x2z=Amplitude(rI1z,I1x2z) %13
A1y2z=Amplitude(rI1z,I1y2z) %14
A1z2x=Amplitude(rI1z,I1z2x) %13
A1z2y=Amplitude(rI1z,I1z2y) %14
%%
%A1x 0
%A1y 0
%simplify(A1z-(1-0.5*(1-cos(w21))*sin(2*T)^2))
%A2x 0
%A2y 0
%simplify(A2z-(0.5*(1-cos(w21))*(sin(2*T)^2)))
%A1z2z 0
%AU 0
%A1x2z 0
%A1y2z 0
%A1z2x 0
%A1z2y 0
%simplify(AZQx-(-0.5*(1-cos(w21))*sin(4*T)))
%simplify(AZQy-(-sin(w21)*sin(2*T)))
%ADQx 0
%ADQy 0

simplify(rI1z-(A1z*I1z+A2z*I2z+AZQx*ZQx+AZQy*ZQy))
%% evolution of the SECOND spin Y magnetization
disp("I2z");

U=eye(4);
w21 = sym("w21","real");
w31 = sym("w31","real");
w42 = sym("w42","real");
w43 = sym("w43","real");

rI2z =  1/2*[                   1,                     0,                       0,        0;
                                0,             -cos(2*T),   -exp(1i*w21)*sin(2*T),        0;
                                0,-exp(-1i*w21)*sin(2*T),                cos(2*T),        0;
                                0,                     0,                       0,       -1];
A1x=Amplitude(rI2z,I1x) %1
A1y=Amplitude(rI2z,I1y) %2
A1z=Amplitude(rI2z,I1z) %3
A2x=Amplitude(rI2z,I2x) %4       
A2y=Amplitude(rI2z,I2y) %5
A2z=Amplitude(rI2z,I2z) %6
A1z2z=Amplitude(rI2z,I1z*I1z) %7
AZQx=Amplitude(rI2z,ZQx) %8
AZQy=Amplitude(rI2z,ZQy) %9
ADQx=Amplitude(rI2z,DQx) %10
ADQy=Amplitude(rI2z,DQy) %11
AU=Amplitude(rI2z,U) %12
A1x2z=Amplitude(rI2z,I1x2z) %13
A1y2z=Amplitude(rI2z,I1y2z) %14
A1z2x=Amplitude(rI2z,I1z2x) %13
A1z2y=Amplitude(rI2z,I1z2y) %14
%%
%A1x 0
%A1y 0
%simplify(A1z-(0.5*(1-cos(w21))*(sin(2*T)^2)))
%A2x 0
%A2y 0
%simplify(A2z-(1-0.5*(1-cos(w21))*sin(2*T)^2))
%A1z2z 0
%AU 0
%A1x2z 0
%A1y2z 0
%A1z2x 0
%A1z2y 0
%simplify(AZQx-(0.5*(1-cos(w21))*sin(4*T)))
simplify(AZQy-(sin(w21)*sin(2*T)))
%ADQx 0
%ADQy 0
%simplify(rI2z-(A1z*I1z+A2z*I2z+AZQx*ZQx+AZQy*ZQy))
%%


%%
function DisplayDensityMatrix(r,S,Q,QE)
    r. ShowOperators(S,1e-4)
    disp("Zeeman basis")
    disp(full(r.val))
    disp("S-T basis")
    disp(Q\full(r.val)*Q)
    disp("Eigen basis of H")
    disp(simplify(QE\full(r.val)*QE))
end

function out = Amplitude(A,B)
amp=simplify(trace(A*B'))/(trace(B*B'));
out = simplify(amp);

end


