%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(10);% 9 10
ex=Load_SABRE_System(System);

ex.Folder="out\SABRESHEATH_"+System;
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH=1;                              % pH2 fraction (1 - 100)%
%ex.Kd =10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa =ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd = 1;                             % [s^-1] dissociation rate for exC
ex.Bv=400*1e-9;   % delay/storage external magnetic field, T
%% magnetic fields %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.tv=100;   % delay/storage external magnetic field, T
%% rhos for exC SABRE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.Yout = sabre_exC_tB(ex);

%% plot
figure("Color","white")
%semilogx(ex.Bv,ex.Yout.c{ex.show_c(1)}*100,'b',"LineWidth",2);
plot(ex.Bv*1e9,ex.Yout.c{ex.show_c(1)}*100,'b',"LineWidth",2);
hold on
plot(ex.Bv*1e9,ex.Yout.c{ex.show_c(2)}*100,'r',"LineWidth",2);
%semilogx(ex.Bv,ex.Yout.c{ex.show_c(2)}*100,'r',"LineWidth",2);
%semilogx(ex.Bv,ex.Yout.c{ex.show_c(3)}*100,'g',"LineWidth",2);
legend(ex.SOcStr(ex.show_c(1:2)));
axis([0,1000,-5,20]);
xlabel("B (nT)");
ylabel("Polarization (%)");
title("SABRE SHEATH with tb = "+num2str(ex.tv,3)+"s, free substrate");


%% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save(ex.Folder+"_B"+num2str(ex.Bv*1e9)+"nT_Kd"+num2str(ex.Kd)+".mat","ex");
%%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
