%% 1D
    
    disp('start');
    folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_45OPE_VPd6_\';
    file = '2022_12_29_1505_ij_H2_45OPE_ej_9m_3';

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
        
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   -73;            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor

    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);    
    MOIN_1DSpecPlotting(proDat,[-10,10])


%% 20221229 exp1_45OPE_VAd6_overflow max 1.19 from 0.9
    disp('start');
    folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp1_45OPE_VAd6_overflow max 1.19 from 0.9\';
    file = {'2022_12_29_1155_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1158_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1200_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1201_ij_H2_45OPE_ej_8m_3',...
        '2022_12_29_1203_ij_H2_45OPE_ej_7m_3',...
        '2022_12_29_1205_ij_H2_45OPE_ej_6m_3',...
        '2022_12_29_1206_ij_H2_45OPE_ej_5m_3',...
        '2022_12_29_1208_ij_H2_45OPE_ej_4m_3',...
        '2022_12_29_1209_ij_H2_45OPE_ej_3m_3',...
        '2022_12_29_1210_ij_H2_45OPE_ej_2m_3',...
        '2022_12_29_1212_ij_H2_45OPE_ej_1m_3',...
        '2022_12_29_1213_ij_H2_45OPE_ej_10m_3',...
        '2022_12_29_1215_ij_H2_45OPE_ej_11m_3',...
        '2022_12_29_1217_ij_H2_45OPE_ej_12m_3',...
        '2022_12_29_1229_ij_H2_45OPE_ej_14m_3',...
        '2022_12_29_1231_ij_H2_45OPE_ej_17m_3',...
        '2022_12_29_1245_ij_H2_45OPE_ej_9m_3'}
    ppm_shift=[-1.44;-2.5;-5.96;-8;-8.5;-10.5;-9.8;-10.48;-8.8;-9;-11;-10.2;-9;-10;-10.6;-11;-8.3;]
    integrals=zeros(length(file),1);
    x = integrals;

    for k = 1:17%length(file)
        in=load(append(folder,file{k},'.mat'));
        MOIN_Raw=in.MOIN_Raw;    
        MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
            
        proc.LB        =   10;             % line broadening [Hz]
        proc.d0        =   20;            % zero-order phase correction [deg]
        proc.d1        =   0;             % first-order phase correction 
        proc.ZF        =   4;                    % zero fill factor
        limits = [-30,30];
    
        proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);    
        proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
        MOIN_1DSpecPlotting(proDat,limits)
        
        integrals(k) = integral(proDat,limits);
        x(k) = MOIN_Raw.Seq.tau_list;
    end
    figure
    plot(x,integrals,"*")
    out=[x;integrals];
    save(folder+"tau_integral.txt",'out','-ASCII')




%% 20221229 exp2_45OPE_VPd6_
    disp('start');
    folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_45OPE_VPd6_\';
    file = {'2022_12_29_1505_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1510_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1512_ij_H2_45OPE_ej_1m_3',...
        '2022_12_29_1514_ij_H2_45OPE_ej_3m_3',...
        '2022_12_29_1516_ij_H2_45OPE_ej_5m_3',...
        '2022_12_29_1518_ij_H2_45OPE_ej_7m_3',...
        '2022_12_29_1520_ij_H2_45OPE_ej_9m_3',...
        '2022_12_29_1522_ij_H2_45OPE_ej_11m_3',...
        '2022_12_29_1523_ij_H2_45OPE_ej_14m_3',...
        '2022_12_29_1525_ij_H2_45OPE_ej_18m_3',...
        '2022_12_29_1527_ij_H2_45OPE_ej_25m_3',...
        '2022_12_29_1529_ij_H2_45OPE_ej_30m_3',...
        '2022_12_29_1531_ij_H2_45OPE_ej_35m_3',...
        '2022_12_29_1532_ij_H2_45OPE_ej_40m_3',...
        '2022_12_29_1534_ij_H2_45OPE_ej_45m_3',...
        '2022_12_29_1536_ij_H2_45OPE_ej_50m_3',...
        '2022_12_29_1537_ij_H2_45OPE_ej_60m_3'}
    ppm_shift=[-1.5;0.3;2;2;2;2;2;2;3.8;4.8;5;5;5;5.4;3.8;3.8;5.33;];
    d0=[-73,-68,-73,-65,-65,-70,-60,-65,-67,-73,-73,-73,-73,-73,-73,-65,-60];
    integrals=zeros(length(file),1);
    x = integrals;

    for k = 1:17%length(file)
        in=load(append(folder,file{k},'.mat'));
        MOIN_Raw=in.MOIN_Raw;    
        MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
            
        proc.LB        =   10;             % line broadening [Hz]
        proc.d0        =   d0(k);            % zero-order phase correction [deg]
        proc.d1        =   0;             % first-order phase correction 
        proc.ZF        =   4;                    % zero fill factor
        limits = [-10,10];
    
        proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);    
        proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
        MOIN_1DSpecPlotting(proDat,limits)
        
        integrals(k) = integral(proDat,limits);
        x(k) = MOIN_Raw.Seq.tau_list;
    end
    figure
    plot(x,integrals,"*")
    out=[x,integrals];
    save(folder+"tau_integral.txt",'out','-ASCII')

    disp('done');   


%% 20230106\VPyr OPE and Therm lower receiver gain
    % disp('start');
    folders = {'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20230106\VPyrAll\'};
    files = {'2023_01_06_1102_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60'};

    d0       ={-57};
    ppm_shift=[-5];     
    k = 1
    file=files{k};
    folder=folders{1};

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   d0{k};            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor
    limits = [-20,20];
    
    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);        
    proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
    MOIN_1DSpecPlotting(proDat,limits);
    drawnow();
    
    integrals = integral(proDat,limits);
    
    disp('done');   
    



    %% 20230106\VPyr OPE and Therm lower receiver gain
    % disp('start');
    folders = {'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20230106\VPyr\'};
    files = {'2023_01_06_1041_ij_H2_45OPE_ej_45s_9ms_5bar_norf',...
        '2023_01_06_1044_ij_H2_45OPE_ej_45s_9ms_5bar_norf',...
        '2023_01_06_1048_ij_H2_45OPE_ej_30s_9ms_5bar_norf',...        
        '2023_01_06_1053_ij_H2_45OPE_ej_30s_9ms_15bar_norf',...
        '2023_01_06_1056_90FID_acetone_h6_rg60',...
        '2023_01_06_1100_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60',...
        '2023_01_06_1102_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60',...
        '2023_01_06_1105_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60',...
        '2023_01_06_1107_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60',...
        '2023_01_06_1113_ij_H2_45OPE_ej_45s_9ms_15bar_norf_rg60',...
        '2023_01_06_1120_ij_H2_45OPE_ej_45s_9ms_15bar_rf60_rg60',...
        '2023_01_06_1122_ij_H2_45OPE_ej_45s_9ms_15bar_rf60_rg60'
        };

    d0       ={-77,  -60,-47,-85,-63,-58,-57,-80,-70,-72,48,90};
    ppm_shift=[-1.4,-1.5,0,0,0,     -1.5, -5,-5,  -4, -4,-1,-2]; 
    integrals = zeros(12,1);
    for k = 7
    file=files{k};
    folder=folders{1};

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   d0{k};            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor
    limits = [-20,20];
    
    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);        
    proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
    MOIN_1DSpecPlotting(proDat,limits);
    drawnow();
    
    integrals(k) = integral(proDat,limits);

    %out=[proDat.ppmList_ZF,real(proDat.SPEC_ZF_LB_PC)];
    %save(append(folder,file,".txt"),'out','-ASCII')
    
    end
    figure
    plot(integrals)
    disp('done');   
    
     %% 20230106\VAc OPE and Therm lower receiver gain
    % disp('start');
    folders = {'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20230106\VAc\'};
    files = {'2023_01_06_1214_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg250',...
             '2023_01_06_1216_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg250',...
             '2023_01_06_1236_90FID_acetoneh6_rf60_rg200'};

    d0       ={40, 20,30};
    ppm_shift=[-110,0,5.5]; 
    integrals = zeros(3,1);
    for k = 1:3
    file=files{k};
    folder=folders{1};

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   d0{k};            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor
    limits = [-20,20];
    
    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);        
    proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
    MOIN_1DSpecPlotting(proDat,limits);
    drawnow();
    
    integrals(k) = integral(proDat,limits);

    %out=[proDat.ppmList_ZF,real(proDat.SPEC_ZF_LB_PC)];
    %save(append(folder,file,".txt"),'out','-ASCII')
    
    end
    figure
    plot(integrals)
    disp('done');     
    
    
    %% 20230106\VAc OPE and Therm lower receiver gain
    % disp('start');
    folders = {'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20230106\VAc\'};
    files = {'2023_01_06_1139_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg60',...
        '2023_01_06_1140_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg60',...
        '2023_01_06_1142_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg60',...
        '2023_01_06_1147_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1152_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg300',...
        '2023_01_06_1154_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg300',...        
        '2023_01_06_1214_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg250',...
        '2023_01_06_1216_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg250',...
        '2023_01_06_1225_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1227_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1228_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1230_ij_H2_45OPE_ej_30s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1232_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1233_ij_H2_45OPE_ej_20s_9ms_15bar_rf60_rg200',...
        '2023_01_06_1236_90FID_acetoneh6_rf60_rg200'};

    d0       ={70,50,15,35,  50,70, 40, 20, 90,50,90,70,10,30,30};
    ppm_shift=[00,00,00,-110,-5,-5,-110,0,  0, -3,-3,-3,0,0,5.5];
 % 15 thermal and 7/8,13 are high ope, 8 looks good
    integrals = zeros(15,1);
    for k = 8:8
    file=files{k};
    folder=folders{1};

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   d0{k};            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor
    limits = [-20,20];
    
    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);        
    proDat.ppmList_ZF=proDat.ppmList_ZF+ppm_shift(k);
    MOIN_1DSpecPlotting(proDat,limits);
    drawnow();
    
    integrals(k) = integral(proDat,limits);

    %out=[proDat.ppmList_ZF,real(proDat.SPEC_ZF_LB_PC)];
    %save(append(folder,file,".txt"),'out','-ASCII')
    
    end
    figure
    plot(integrals)
    disp('done');   

    %% exp2_45OPE_VPd6_ PASADENA, OPE and Therm
    % disp('start');
    folders = {'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_therm\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_therm\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_therm\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_pasadena_VPd6\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_pasadena_VPd6\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_45OPE_VPd6_\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp2_45OPE_VPd6_\',...
               'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221229\exp1_45OPE_VAd6_overflow max 1.19 from 0.9\'};
    files = {'2022_12_29_1544_90FID_acetoneh6',...
             '2022_12_29_1549_90FID_therm300s',...
             '2022_12_29_1554_90FID_therm300s',...
             '2022_12_29_1507_ij_H2_45_ej_pasadena_wrong',...
             '2022_12_29_1509_ij_H2_45_ej_pasadena',...             
             '2022_12_29_1505_ij_H2_45OPE_ej_9m_3',...
             '2022_12_29_1510_ij_H2_45OPE_ej_9m_3',...
             '2022_12_29_1155_ij_H2_45OPE_ej_9m_3'
             };
    d0={-62,-50,-50,28,28,-73,-68,20};

    k=8;
    file=files{k};
    folder=folders{k};

    in=load(append(folder,file,'.mat'));
    MOIN_Raw=in.MOIN_Raw;    
    MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
    proc.LB        =   10;             % line broadening [Hz]
    proc.d0        =   d0{k};            % zero-order phase correction [deg]
    proc.d1        =   0;             % first-order phase correction 
    proc.ZF        =   4;                    % zero fill factor
    limits = [-10,10];
    
    proDat = MOIN_1DSpecProcessing(MOIN_Raw,proc);        
    MOIN_1DSpecPlotting(proDat,limits)
    
    integrals = integral(proDat,limits)

    out=[proDat.ppmList_ZF,real(proDat.SPEC_ZF_LB_PC)];
    save(append(folder,file,".txt"),'out','-ASCII')
    disp('done');   
   

    %% 20221220 exp1 varytauVP
    disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221220\exp1_VPd6_tau_5bar\';   
files = {'2022_12_20_1510_ij_H2_45CPMG_ej_0.5ms_20s',...
          '2022_12_20_1441_ij_H2_45CPMG_ej_1ms_20s',...
          '2022_12_20_1511_ij_H2_45CPMG_ej_1.5ms_20s',...
          '2022_12_20_1442_ij_H2_45CPMG_ej_2ms_20s',...
          '2022_12_20_1513_ij_H2_45CPMG_ej_2.5ms_20s',...
          '2022_12_20_1443_ij_H2_45CPMG_ej_3ms_20s',...
          '2022_12_20_1514_ij_H2_45CPMG_ej_3.5ms_20s',...
          '2022_12_20_1445_ij_H2_45CPMG_ej_4ms_20s',...
          '2022_12_20_1515_ij_H2_45CPMG_ej_4.5ms_20s',...
          '2022_12_20_1446_ij_H2_45CPMG_ej_5ms_20s',...
          '2022_12_20_1517_ij_H2_45CPMG_ej_5.5ms_20s',...
          '2022_12_20_1447_ij_H2_45CPMG_ej_6ms_20s',...
          '2022_12_20_1450_ij_H2_45CPMG_ej_7ms_20s',...
          '2022_12_20_1452_ij_H2_45CPMG_ej_8ms_20s',...
          '2022_12_20_1453_ij_H2_45CPMG_ej_9ms_20s',...
          '2022_12_20_1455_ij_H2_45CPMG_ej_10ms_20s',...
          '2022_12_20_1457_ij_H2_45CPMG_ej_11ms_20s',...
          '2022_12_20_1458_ij_H2_45CPMG_ej_12ms_20s',...
          '2022_12_20_1500_ij_H2_45CPMG_ej_13ms_20s',...
          '2022_12_20_1501_ij_H2_45CPMG_ej_14ms_20s',...
          '2022_12_20_1502_ij_H2_45CPMG_ej_15ms_20s',...
          '2022_12_20_1503_ij_H2_45CPMG_ej_16ms_20s',...
          '2022_12_20_1505_ij_H2_45CPMG_ej_17ms_20s',...
          '2022_12_20_1506_ij_H2_45CPMG_ej_18ms_20s',...
          '2022_12_20_1507_ij_H2_45CPMG_ej_19ms_20s',...
          '2022_12_20_1509_ij_H2_45CPMG_ej_20ms_20s'};
          

texts.x='The number of echoes';
texts.y='\tau (ms)';
texts.folder=folder;
[time, Y]=load_and_combine(folder,files,'max');
texts.tag='1 varytau VP';
plot_and_save(texts,time.tau,Y)
texts.x='2n \tau ';
plot_and_save_ntau(texts,time.tau,Y)


disp('done');
    
    
    %% 3varytauVA
    disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\3varytauVA\';
%'2022_11_25_1625_ij_H2_45CPMG_ej_5ms',...%here also 4 ms
%'2022_11_25_1636_ij_H2_45CPMG_ej_9ms_1',... 
%'2022_11_25_1638_ij_H2_45CPMG_ej_9ms_2',...       
files = {'2022_11_25_1618_ij_H2_45CPMG_ej_1ms',...
          '2022_11_25_1619_ij_H2_45CPMG_ej_2ms',...
          '2022_11_25_1621_ij_H2_45CPMG_ej_3ms',...
          '2022_11_25_1623_ij_H2_45CPMG_ej_4ms',...          
          '2022_11_25_1628_ij_H2_45CPMG_ej_5ms',...
          '2022_11_25_1630_ij_H2_45CPMG_ej_6ms',...
          '2022_11_25_1632_ij_H2_45CPMG_ej_7ms',...
          '2022_11_25_1635_ij_H2_45CPMG_ej_8ms',...          
          '2022_11_25_1639_ij_H2_45CPMG_ej_10ms',...
          '2022_11_25_1641_ij_H2_45CPMG_ej_11ms',...
          '2022_11_25_1643_ij_H2_45CPMG_ej_12ms',...
          '2022_11_25_1645_ij_H2_45CPMG_ej_13ms',...
          '2022_11_25_1646_ij_H2_45CPMG_ej_14ms',...
          '2022_11_25_1648_ij_H2_45CPMG_ej_15ms',...
          '2022_11_25_1649_ij_H2_45CPMG_ej_16ms',...
          '2022_11_25_1651_ij_H2_45CPMG_ej_17ms',...
          '2022_11_25_1652_ij_H2_45CPMG_ej_18ms',...
          '2022_11_25_1654_ij_H2_45CPMG_ej_19ms',...
          '2022_11_25_1655_ij_H2_45CPMG_ej_20ms',...
          '2022_11_25_1658_ij_H2_45CPMG_ej_1.5ms',...
          '2022_11_25_1700_ij_H2_45CPMG_ej_2.5ms',...
          '2022_11_25_1701_ij_H2_45CPMG_ej_3.5',...
          '2022_11_25_1703_ij_H2_45CPMG_ej_4.5',...
          '2022_11_25_1705_ij_H2_45CPMG_ej_5.5ms'};

texts.x='The number of echoes';
texts.y='\tau (ms)';
texts.folder=folder;
[time, Y]=load_and_combine(folder,files,'max');
texts.tag='3varytauVA';
plot_and_save(texts,time.tau,Y)
texts.x='2n \tau ';
plot_and_save_ntau(texts,time.tau,Y)


disp('done');
%% 2varytauEFP
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\2varytauEFP\';
      
files = {'2022_11_25_1457_ij_H2_45CPMG_ej_1ms',...
    '2022_11_25_1459_ij_H2_45CPMG_ej_2ms',...
    '2022_11_25_1501_ij_H2_45CPMG_ej_3ms',...
    '2022_11_25_1502_ij_H2_45CPMG_ej_4ms',...
    '2022_11_25_1505_ij_H2_45CPMG_ej_3ms',...
    '2022_11_25_1506_ij_H2_45CPMG_ej_5ms',...
    '2022_11_25_1507_ij_H2_45CPMG_ej_6ms',...
    '2022_11_25_1510_ij_H2_45CPMG_ej_7ms',...
    '2022_11_25_1511_ij_H2_45CPMG_ej_8ms',...
    '2022_11_25_1513_ij_H2_45CPMG_ej_9ms',...
    '2022_11_25_1514_ij_H2_45CPMG_ej_10ms',...
    '2022_11_25_1516_ij_H2_45CPMG_ej_11ms',...
    '2022_11_25_1517_ij_H2_45CPMG_ej_12ms',...
    '2022_11_25_1518_ij_H2_45CPMG_ej_13ms',...
    '2022_11_25_1520_ij_H2_45CPMG_ej_14ms',...
    '2022_11_25_1521_ij_H2_45CPMG_ej_15ms',...
    '2022_11_25_1523_ij_H2_45CPMG_ej_16ms',...
    '2022_11_25_1524_ij_H2_45CPMG_ej_17ms',...
    '2022_11_25_1526_ij_H2_45CPMG_ej_18ms',...
    '2022_11_25_1527_ij_H2_45CPMG_ej_19ms',...
    '2022_11_25_1528_ij_H2_45CPMG_ej_20ms',...
    '2022_11_25_1531_ij_H2_45CPMG_ej_05ms',...
    '2022_11_25_1532_ij_H2_45CPMG_ej_1.5ms',...
    '2022_11_25_1533_ij_H2_45CPMG_ej_2.5ms',...
    '2022_11_25_1534_ij_H2_45CPMG_ej_3.5ms',...
    '2022_11_25_1536_ij_H2_45CPMG_ej_4.5ms',...
    '2022_11_25_1537_ij_H2_45CPMG_ej_5.5ms'    
    };

texts.x='The number of echoes';
texts.y='\tau (ms)';
texts.folder=folder;
[time, Y]=load_and_combine(folder,files,'max');
texts.tag='2varytauEFP';
plot_and_save(texts,time.tau,Y)

texts.x='2n \tau ';
plot_and_save_ntau(texts,time.tau,Y)

disp('done');



%% exp3 varybubblingtime VPD6 15bar
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab_MA\MOIN_Code\data\20221220\exp3_VPd6_tbabl_15bar\';
      
files = {
        '2022_12_20_1545_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1546_ij_H2_45CPMG_ej_5ms_1s',...
        '2022_12_20_1548_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1549_ij_H2_45CPMG_ej_5ms_2s',...
        '2022_12_20_1550_ij_H2_45CPMG_ej_5ms_3s',...
        '2022_12_20_1551_ij_H2_45CPMG_ej_5ms_5s',...
        '2022_12_20_1552_ij_H2_45CPMG_ej_5ms_8.5s',...
        '2022_12_20_1553_ij_H2_45CPMG_ej_5ms_10s',...
        '2022_12_20_1555_ij_H2_45CPMG_ej_5ms_15s',...
        '2022_12_20_1556_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1557_ij_H2_45CPMG_ej_5ms_40s',...
        '2022_12_20_1559_ij_H2_45CPMG_ej_5ms_60s',...
        '2022_12_20_1602_ij_H2_45CPMG_ej_5ms_80s',...
        '2022_12_20_1605_ij_H2_45CPMG_ej_5ms_120s',...
        '2022_12_20_1606_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1608_ij_H2_45CPMG_ej_5ms_50s',...
        '2022_12_20_1609_ij_H2_45CPMG_ej_5ms_30s',...
        '2022_12_20_1611_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1612_ij_H2_45CPMG_ej_5ms_6s'};

[time, Y]=load_and_combine(folder,files,'max');

texts.x='The number of echoes';
texts.y='bubbling time (s)';
texts.folder=folder;
texts.tag='3varybubblingtimeVPd6_15bar';
plot_and_save(texts,time.bubbleTime,Y)
figure('Color','white')
%
texts.xlabel='bubbling time (s)';
texts.plotstd = 'no';
texts.ylabel='Abs. signal (norm.)';
plot1D(texts,time.bubbleTime,Y(:,15))
disp('done');


%% exp2 varybubblingtime VPD6 5 bar
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab_MA\MOIN_Code\data\20221220\exp2_VPd6_tbabl_5bar\';
      
files = {'2022_12_20_1446_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1518_ij_H2_45CPMG_ej_5ms_10s',...
        '2022_12_20_1519_ij_H2_45CPMG_ej_5ms_2s',...
        '2022_12_20_1520_ij_H2_45CPMG_ej_5ms_1s',...
        '2022_12_20_1521_ij_H2_45CPMG_ej_5ms_3s',...
        '2022_12_20_1522_ij_H2_45CPMG_ej_5ms_5s',...
        '2022_12_20_1525_ij_H2_45CPMG_ej_5ms_8.5s',...
        '2022_12_20_1526_ij_H2_45CPMG_ej_5ms_15s',...
        '2022_12_20_1527_ij_H2_45CPMG_ej_5ms_20s',...
        '2022_12_20_1529_ij_H2_45CPMG_ej_5ms_40s',...
        '2022_12_20_1531_ij_H2_45CPMG_ej_5ms_60s',...
        '2022_12_20_1533_ij_H2_45CPMG_ej_5ms_80s',...
        '2022_12_20_1536_ij_H2_45CPMG_ej_5ms_120s',...
        '2022_12_20_1537_ij_H2_45CPMG_ej_5ms_20s'};

[time, Y]=load_and_combine(folder,files,'max');

texts.x='The number of echoes';
texts.y='bubbling time (s)';
texts.folder=folder;
texts.tag='2varybubblingtimeVPd6_5bar';
plot_and_save(texts,time.bubbleTime,Y)
figure('Color','white')
%
texts.xlabel='bubbling time (s)';
texts.plotstd = 'no';
texts.ylabel='Abs. signal (norm.)';
plot1D(texts,time.bubbleTime,Y(:,15))
disp('done');



%% 3varybubblingtimeVA
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\3varybubblingtimeVA\';
      
files = {'2022_11_25_1707_ij_H2_45CPMG_ej_4ms_20s_1s',...
         '2022_11_25_1708_ij_H2_45CPMG_ej_4ms_1s_1s',...
         '2022_11_25_1709_ij_H2_45CPMG_ej_4ms_2s_1s',...
         '2022_11_25_1711_ij_H2_45CPMG_ej_4ms_4s_1s',...
         '2022_11_25_1712_ij_H2_45CPMG_ej_4ms_8s_1s',...
         '2022_11_25_1713_ij_H2_45CPMG_ej_4ms_16s_1s',...
         '2022_11_25_1715_ij_H2_45CPMG_ej_4ms_25s_1s',...
         '2022_11_25_1716_ij_H2_45CPMG_ej_4ms_40s_1s',...
         '2022_11_25_1719_ij_H2_45CPMG_ej_4ms_80s_1s',...
         '2022_11_25_1723_ij_H2_45CPMG_ej_4ms_120s_1s',...
         '2022_11_25_1726_ij_H2_45CPMG_ej_4ms_60s_1s'};

[time, Y]=load_and_combine(folder,files,'max');

texts.x='The number of echoes';
texts.y='bubbling time (s)';
texts.folder=folder;
texts.tag='3varybubblingtimeVA';
plot_and_save(texts,time.bubbleTime,Y)
figure('Color','white')
%
texts.xlabel='bubbling time (s)';
texts.plotstd = 'no';
texts.ylabel='Abs. signal (norm.)';
plot1D(texts,time.bubbleTime,Y(:,15))
disp('done');


%% 2varybubblingtimeEFP
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\2varybubblingtimeEFP\';
      
files = {'2022_11_25_1538_ij_H2_45CPMG_ej_5ms1s1s',...
         '2022_11_25_1540_ij_H2_45CPMG_ej_5ms2s1s',...
         '2022_11_25_1542_ij_H2_45CPMG_ej_5ms4s1s',...
         '2022_11_25_1543_ij_H2_45CPMG_ej_5ms8s1s',...
         '2022_11_25_1544_ij_H2_45CPMG_ej_5ms12ms1s',...
         '2022_11_25_1546_ij_H2_45CPMG_ej_5ms18s1s',...
         '2022_11_25_1547_ij_H2_45CPMG_ej_5ms30s1s',...
         '2022_11_25_1549_ij_H2_45CPMG_ej_5ms50s1s',...
         '2022_11_25_1551_ij_H2_45CPMG_ej_5ms10s1s',...
         '2022_11_25_1552_ij_H2_45CPMG_ej_5ms5s1s',...
         '2022_11_25_1554_ij_H2_45CPMG_ej_5ms25s1s',...
         '2022_11_25_1557_ij_H2_45CPMG_ej_5ms80s1s'};

[time, Y]=load_and_combine(folder,files,'max');

texts.x='The number of echoes';
texts.y='bubbling time (s)';
texts.folder=folder;
texts.tag='2varybubblingtimeEFP';
plot_and_save(texts,time.bubbleTime,Y)

%
texts.xlabel='bubbling time (s)';
texts.plotstd = 'no';
texts.ylabel='Abs. signal (norm.)';
plot1D(texts,time.bubbleTime,Y(:,25))
disp('done');


%% 4varybubblingVA15bar
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\4varybubblingVA15bar\';
      
files ={'2022_11_25_1812_ij_H2_45CPMG_ej_15bar_4ms_1s_1s',...
        '2022_11_25_1813_ij_H2_45CPMG_ej_15bar_4ms_2s_1s',...
        '2022_11_25_1815_ij_H2_45CPMG_ej_15bar_4ms_4s_1s',...
        '2022_11_25_1816_ij_H2_45CPMG_ej_15bar_4ms_8s_1s',...
        '2022_11_25_1819_ij_H2_45CPMG_ej_15bar_4ms_16s_1s',...
        '2022_11_25_1821_ij_H2_45CPMG_ej_15bar_4ms_32s_1s',...
        '2022_11_25_1822_ij_H2_45CPMG_ej_15bar_4ms_25s_1s',...
        '2022_11_25_1824_ij_H2_45CPMG_ej_15bar_4ms_40s_1s',...
        '2022_11_25_1826_ij_H2_45CPMG_ej_15bar_4ms_80s_1s',...
        '2022_11_25_1830_ij_H2_45CPMG_ej_15bar_4ms_120s_1s',...
        '2022_11_25_1832_ij_H2_45CPMG_ej_15bar_4ms_60s_1s',...
        '2022_11_25_1834_ij_H2_45CPMG_ej_15bar_4ms_13s_1s',...
        '2022_11_25_1837_ij_H2_45CPMG_ej_15bar_4ms_11s_1s'};

[time, Y]=load_and_combine(folder,files,'max');

texts.x='The number of echoes';
texts.y='bubbling time (s)';
texts.folder=folder;
texts.tag='4varybubblingVA15bar';
plot_and_save(texts,time.bubbleTime,Y)

%
texts.xlabel='bubbling time (s)';
texts.plotstd = 'no';
texts.ylabel='Abs. signal (norm.)';
plot1D(texts,time.bubbleTime,Y(:,15))
disp('done');


%% 5reproducibilityEFP15bar
disp('start');
folder = 'C:\Users\CAUUser\Desktop\openMatlab\MOIN_Code\data\20221125\5reproducibilityEFP15bar\';
      
files ={'2022_11_25_1853_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1855_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1856_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1858_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1859_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1900_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1902_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1903_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1904_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1906_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1907_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1908_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1910_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1911_ij_H2_45CPMG_ej_5ms_20s_1s',...
        '2022_11_25_1912_ij_H2_45CPMG_ej_5ms_20s_1s'};

[time, Y]=load_and_combine(folder,files,'max');
time.repetition = 1:length(files);
texts.x='The number of echoes';
texts.y='The number of repetitions';
texts.folder=folder;
texts.tag='5reproducibilityEFP15bar';
plot_and_save(texts,time.repetition,Y)

%
texts.xlabel='The number of repetitions';
texts.ylabel='Abs. signal (norm.)';
texts.plotstd = 'yes';
plot1D(texts,time.repetition,Y(:,18))
disp('done');


%%

function plot1D(texts,X,Y)
    [m, n]=size(X);
    if m>n
        X=X';
    end

    f=figure('Name','Measured Data','Color','white');    
    ax=axes('Box','on');    
    
    
    if strcmp(texts.plotstd,'yes')
        Y=Y/mean(Y);    
        Ystd=std(Y);
        Xfill = [0 X max(X)+1];
        x_vector = [Xfill, fliplr(Xfill)];
        disp(['std=',num2str(Ystd)]);
        patch = fill(x_vector, [Xfill*0+1+Ystd,Xfill*0+1-Ystd], 'b');
        set(patch, 'edgecolor', 'none');
        set(patch, 'FaceAlpha', 0.2);
        hold on
    else
        Y=Y/max(Y);
    end
    plot(X,Y,"Marker","o","LineStyle","none",'LineWidth',2);
    hold off
    ax.set('FontSize',20,'FontName','Arial','TickDir','out','TickLength',[0.02 0.025],'XMinorTick','on','YMinorTick','on','Box','on','LineWidth',2);
    xlabel(texts.xlabel,'FontSize',20,'FontName','Arial')    
    axis([0,max(X)+0.5,0,1.3])

    imagewd = getframe(gcf); 
    imwrite(imagewd.cdata, [texts.folder,texts.tag,'_image1D.png'],"Compression","none");
    out=[X',Y];
    save([texts.folder,texts.tag,'_image1D.dat'],'out','-ASCII');
end

%
function plot_and_save(texts,TE,Y)
    
    texts.title={' ',' '};
    texts.colorbar='|Signal| (norm.)';
    X1 = TE;
    X2 = 1:length(Y);
    [X1,X2]=meshgrid(X2,X1);
    Z=abs(Y);
    Z=Z/max(max(Z));
    plot2D(X1,X2,Z,texts);
    axis([min(min(X1)),100,min(min(X2)),max(max(X2))])
    %imagewd = getframe(gcf); 
    %imwrite(imagewd.cdata, ,"Compression","none");
    saveas(gcf,[texts.folder,texts.tag,'_tau_n_image2D.png']);

end

function plot_and_save_ntau(texts,TE,Y)
    
    texts.title={' ',' '};
    texts.colorbar='|Signal| (norm.)';
    
    [X2,~]=meshgrid(TE,1:length(Y));
    X1=2*(1:length(Y))'*TE';
    Z=abs(Y');
    Z=Z/max(max(Z));
    plot2D(X1,X2,Z/max(max(Z)),texts);
    axis([1,1000,1,20])
    %imagewd = getframe(gcf); 
    %imwrite(imagewd.cdata, [texts.folder,texts.tag,'_tau_2ntau_image2D.png'],"Compression","none");
    saveas(gcf,[texts.folder,texts.tag,'_tau_2ntau_image2D.png']);
end



%
function [time, Y]=load_and_combine(folder,files,data_type)
    time.tau=zeros(length(files),1);
    time.bubbleTime=zeros(length(files),1);

    trains=169;
    Y = zeros(length(files),trains);
    
    for ik = 1:length(files)
        in=load(append(folder,files{ik},'.mat'));
        MOIN_Raw=in.MOIN_Raw;    
        MOIN_Raw.HW.fLarmor=MOIN_Raw.HW_fLarmor;
    
        plot_type.limits      = [0,1];
        %plot_type.data_select = 'MaxABS_FID';
        %plot_type.data_select = 'PC_FID';
        plot_type.data_select = 'MaxABS_and_PC_FID';
        LB              =   0;             % line broadening [Hz]
        phase.d0        =   70;            % zero-order phase correction [deg]
        phase.d1        =   0;             % first-order phase correction 
        phase.echo      =   -2e-6;
    
        % Process data
        proDat = MOIN_GeneralCPMG_Processing(MOIN_Raw,LB,phase);
        time.tau(ik)=MOIN_Raw.Seq.tau*1e3;
        time.bubbleTime(ik)=MOIN_Raw.Seq.bubbleTime;
        switch data_type
            case 'max'
                Y(ik,:) = proDat.MAXABSPTS;
            case 'sum'                
                Y(ik,:) = proDat.SUMABSPTS;
            otherwise
                error('only max or sum')
        end
        %
        %MOIN_GeneralCPMG_Plotting(proDat,plot_type)
        %drawnow()
        %sleep(1)
    end
end


function val = integral(proDat,limits)    
    [v1,m1] = min(abs(proDat.ppmList_ZF-limits(1)));
    [v2,m2] = min(abs(proDat.ppmList_ZF-limits(2)));
    in1=min(m1,m2);
    in2=max(m1,m2);
    X=proDat.ppmList_ZF(in2:-1:in1);
    Y=real(proDat.SPEC_ZF_LB_PC(in2:-1:in1));    
    val = trapz(X,Y);    
end

