p             = LoadPath('AP')                                             ;

System        = Load_System_Name(36)                                       ;
SOTs{1}       = "ESOTHERIC"                                                ;
SOTs{2}       = "ESOTHERICn1n2n3"                                          ;
SOTs{3}       = "ESOTHERICn1n2n3_CP"                                       ;
SOTs{4}       = "Goldman"                                                  ;
SOTs{5}       = "phINEPTplus"                                              ;
SOT           = SOTs{5}                                                    ;

Folder        = "out\"                                                     ;

B0=9.4;
%ex.nRef = [3,3,3];
if strcmp(SOT,"ESOTHERICn1n2n3")
    SOT=SOT+sprintf("_%d_%d_%d_",ex.nRef);
end
if strcmp(SOT,"ESOTHERICn1n2n3_CP")
    SOT=SOT+sprintf("_%d_%d_%d_",ex.nRef);
end

in=load("out/"+SOT+System+"_"+num2str(B0)+"T.mat");
ex=in.ex;



%plot_Ymap(ex,Ymap);
[X, Y] = meshgrid(ex.tau1v*1e3,ex.tau2v*1e3);
Z=ex.Amplitudes.X;
texts.x = '\tau_1, ms';
texts.y = '\tau_2, ms';

texts.title = ' ';
texts.CC=-100:20:100;
ax=plot2D(X,Y,Z,texts,'CC');

t1max=250*1e-3;
t2max=150*1e-3;
[m, nt1]=min(abs(ex.tau1v-t1max));
[m, nt2]=min(abs(ex.tau2v-t2max));

[m, n1]=max(max(abs(Z(1:nt2,1:nt1))));
[m, n2]=max(abs(Z(1:nt2,n1)));
fprintf("tau 1 = %.2f, tau 2  = %.2f, maxP  = %.2f \n", [ex.tau1v(n1)*1e3, ex.tau2v(n2)*1e3, Z(n2,n1)]);

t1set=161*1e-3;
t2set=70*1e-3;
[m, nts1]=min(abs(ex.tau1v-t1set));
[m, nts2]=min(abs(ex.tau2v-t2set));
fprintf("polarizatoin at tau 1 = %.2f, tau 2  = %.2f, maxP  = %.2f \n", [t1set*1e3, t2set*1e3, Z(nts2,nts1)]);



imagewd = getframe(gcf); 
imwrite(imagewd.cdata, Folder+SOT+System+"_"+num2str(B0)+"T.tiff",'Compression','none','Resolution',300);
% 0.7787*100+0.2031*73.6+0.0177*54.2+0.0005*39.9 = 93.8%

