close all
clear all
tic 
p = LoadPath();
% p              = LoadPath()                                                ;
% 
% File           = "G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\data\Figure_6\Py_280k_SEXSY";
% data_in        = load(File + '.txt','-ASCII')                              ;
% data.tau0      = data_in(:,1)                                              ;
% data.ey0       = data_in(:,2)                                              ;
% data.fy0       = data_in(:,3)                                              ;
% 
% 
% File           = "G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\data\Figure_6\Py_280k_SEXSY_simdata_Biexponential";
% data_in        = load(File + '.txt','-ASCII')                              ;
% data.tau1      = data_in(:,1)                                              ;
% data.ey1       = data_in(:,2)                                              ;
% data.fy1       = data_in(:,3)                                              ;
% 
% 
% File           = "G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\data\Figure_6\Py_280k_SEXSY_simdata_Cs=S2 Matrixka";
% data_in        = load(File + '.txt','-ASCII')                              ;
% data.tau2      = data_in(:,1)                                              ;
% data.ey2       = data_in(:,2)                                              ;
% data.fy2       = data_in(:,3)                                              ;
% 
% File           = "G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\data\Figure_6\Py_280k_SEXSY_simdata_S-Cs-S Matrixka";
% data_in        = load(File + '.txt','-ASCII')                              ;
% data.tau3      = data_in(:,1)                                              ;
% data.ey3       = data_in(:,2)                                              ;
% data.fy3       = data_in(:,3)                                              ;
% 
% figure("Color","white",'DefaultAxesFontSize',25,'Position',[1050 300 1000 900])                                                    ;
% semilogx(data.tau0, data.ey0, 'ob', data.tau0, data.fy0, 'or','LineWidth',5.2)                                                     ;
% hold on                                                                                                                            ;
% semilogx(data.tau1, data.ey1, 'b', data.tau1, data.fy1, 'r','LineWidth',2)                                                         ; 
% hold on                                                                                                                            ;
% semilogx(data.tau2, data.ey2, 'b:', data.tau2, data.fy2, 'r:','LineWidth',3)                                                       ;     
% hold on                                                                                                                            ;
% semilogx(data.tau3, data.ey3, 'b--', data.tau3, data.fy3, 'r--','LineWidth',2)                                                     ;     
% ylim([-1.01 0])                                                                                                                    ;
% xlim([0.05 5])
% legend('ePy', 'fPy','Eigen values','CsS2↔S','CsS2↔CsS+S')                                                                        ;
% legend('boxoff')

%saveas(gcf,'G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\Figure\Figure6_Fitting\Fitting.png')

%%%%%%%%%%%%%%% set parameters 

S0 = 80 ;   Ir0  = 4;         Rf = 1/10;  Rb = 1/2;  kd = 5                                       ; % Initial constant 
ka=10;
xdata                         = logspace(log10(0.001),log10(10),100)'                                                  ;
data.r                        = zeros(size(xdata))                                                                    ; % Define third column zeros CsS     
Nt                            = length(xdata)                                                                         ;
xdata_fit                     = reshape(xdata*[1,1],2*Nt,1)                                                           ;

S    = Substrate_concentration(kd,ka,S0,Ir0)                                          
CsS2                          = S0-2*Ir0-S                       
CsS                           = Ir0-CsS2  
K    = S/CsS2

%Mb = 2*CsS2 ;   Mf = S;   Mr = CsS;
Mb = -2*CsS2 ;   Mf = 0;   Mr = 0;
% %%%%%%%%%%%%% 'CSS2↔CSS+S MatrixkaRf'                             
                                                                         %(x, S0, Ir0, Mb, Mf, Mr,Rf, kd, ka, Rb)
y0                          = SABRE_twosite_exchange_LmatrixkaRf(xdata_fit, S0, Ir0, Mb, Mr, Mf,Rf, kd, ka, Rb)               ;

%% %%%%%%%%%%%%%%%%%% 'CSS2↔S2 MatrixkaRf'  
                                                            %(kd,Rb, Rf, K, Mb, Mf,  x)
y01                         = SABRE_onesite_exchange_Lmatrix2(kd,Rb, Rf, K, Mb, Mf, xdata_fit) ;

%% %%%%%%%%%%%%%%%%% 'CSS2↔S'
                                                                  %(kd, Rb, Rf, K, Mb, Mf, x)
y02                         = SABRE_onesite_exchange_Lmatrix2kaprime(kd, Rb, Rf, K, Mb, Mf, xdata_fit) ;


figure("Color","white",'DefaultAxesFontSize',25,'Position',[1050 300 1000 900])

semilogx(xdata, y0(1:100), 'b',xdata, y0(101:end), 'r','LineWidth',5.2)                                                           ;
hold on 
semilogx(xdata, y01(1:100), 'c:',xdata, y01(101:end), 'm:','LineWidth',3)                                                           ;
hold on 
semilogx(xdata, y02(1:100), 'b--',xdata, y02(101:end), 'r--','LineWidth',2)                                                           ;
%ylim([0 1])                                                                                                                    ;
xlim([0.001 90])
legend('C_SS_2↔C_SS+S','C_SS_2↔C_SS+S', 'C_SS_2↔S_2', 'C_SS_2↔S_2','C_SS_2↔S','C_SS_2↔S')                                                                        ;
legend('boxoff')

%ylabel("here should be M_Z/P (mM)") %% make italic things!
%xlabel("d_m_i_x (s)")
%title("3 Fitting Models")
%%
%PAPER = [xdata,y0(1:100), y0(101:end),y01(1:100), y01(101:end),y02(1:100), y02(101:end)];
%csvwrite('G:\.shortcut-targets-by-id\1-XRbGQ-3Z93DOptEdwjJ6iviB1PC2QTI\2P_PHIP_and_more\paper_1H_SABRE_EXCHANGE\Figure\SM_Figure_S1_Models\B.csv',PAPER)


% figure("Color","white",'DefaultAxesFontSize',25,'Position',[1050 300 1000 900])                                                    ;
% semilogx(data.tau0, data.ey0, 'ob', data.tau0, data.fy0, 'or','LineWidth',5.2)                                                     ;
% hold on                                                                                                                            ;
% semilogx(data.tau1, data.ey1, 'b', data.tau1, data.fy1, 'r','LineWidth',2)                                                         ; 
% hold on                                                                                                                            ;
% semilogx(data.tau2, data.ey2, 'b:', data.tau2, data.fy2, 'r:','LineWidth',3)                                                       ;     
% hold on                                                                                                                            ;
% semilogx(data.tau3, data.ey3, 'b--', data.tau3, data.fy3, 'r--','LineWidth',2)                                                     ;     
% ylim([-1.01 0])                                                                                                                    ;
% xlim([0.05 5])
% legend('ePy', 'fPy','Eigen values','CsS2↔S','CsS2↔CsS+S')                                                                        ;
% legend('boxoff')

toc