% HH-C system 3x3x1x10000, time 443s
% HH-C system 9x9x1x10000, time 4101s
% HH-C system 45x41x1x10000, time 92592 s
%plot([3*3*1*10000,9*9*1*10000,45*41*1*10000],[443,4101,92592])
%asdf
%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(5);
ex=Load_SABRE_System(System);

ex.Folder="out\realSLIC_SHEATH_SABRE_"+System+"_49.96uT_2uT.mat";
%% change these parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
B0_field = 49.9526*1e-6; % [uT]
% field to v1 conversion for 13C
ex.B1_field = 1*1e-6; % [uT]
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH= 1;                              % pH2 fraction (1 - 100)%
%ex.Kd = 10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa = ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd = 10;                             % [s^-1] dissociation rate for exC
%% SLIC parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.B0 = B0_field; % uT field
% rf on 13C
ex.v1 = ex.B1_field*(ex.Ss.gamma{end}/(2*pi)); % field in Hz, field in uT in []
ex.v1v = ex.v1/ex.Ss.g_gh{end};     % in [Hz] for 1H gamma!
ex.vrf = -535; % Hz resonancing frequency
ex.slic.NT = 30000; % number of slic periods
ex.slic.N = 61*ex.slic.NT; % number of points in slic
ex.slic.T=abs(1/ex.vrf); % period [s]
ex.slic.Ttot = ex.slic.NT * ex.slic.T;
ex.slic.time = linspace(0,ex.slic.Ttot,ex.slic.N);
ex.SLIC.dt = ex.slic.time(2)-ex.slic.time(1);
ex.slic.mod = 10; %Hz
ex.slic.shape = 2*sin(2*pi*ex.vrf*ex.slic.time); % shape of slic pulse 2 x sin
%ex.slic.shape = 4*sin(2*pi*ex.vrf*ex.slic.time).*sin(2*pi*ex.slic.mod*ex.slic.time); % shape of slic pulse 2 x sin * cos
%ex.slic.shape = 2*sin(2*pi*(ex.vrf+20*sawtooth(2*pi*10*ex.slic.time)).*ex.slic.time); % shape of slic pulse 2 x sin * cos
ex.v1slic = ex.v1v*ex.slic.shape;
plot(ex.slic.time,ex.slic.shape);

ex.prebubble = 0.1; % s

ex.vrf/((1+ex.ppmC(3))*ex.Sc.gamma{3}/2/pi)*1e6 % resonance frequency of 13C
%%
ex = sabre_exC_ULF_realSLIC_t_B0_v1_adiabatic_frq(ex);
%%
disp(ex.Yout.ic);
save(ex.Folder,"ex")
disp("finish")
%% 
ex.Yout.abs=(ex.Yout.kin(:,1).^2+ex.Yout.kin(:,3).^2).^0.5;
plot(ex.slic.time,ex.Yout.kin(:,1:3))
xlabel("time slic, s")
ylabel("polarizaiton %")
hold on
plot(ex.slic.time,ex.Yout.abs,"LineWidth",2)
legend(["x","z","y","tr"])
hold off

%% %%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc


