% HH-C system 37x10000, time 582


%asdf
%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(5);
ex=Load_SABRE_System(System);

ex.Folder="out\realSLIC_SHEATH_SABRE_"+System+"_49.96uT_2uT_2BsinDSweepDecay2s_phase.mat";

%% load density matrix
%in=load("P:\public\section\own_contributions\papers\2025_MS_experimental_approach_of_SLIC-SABRE\Data\Simulations\20250124_realSLIC_SHEATH_SABRE_HH-C_49.96uT_2uT.mat");
in=load("out\realSLIC_SHEATH_SABRE_HH-C_49.96uT_2uT.mat");
ex.rC=in.ex.rC; % load 

%% change these parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
B0_field = 49.9526*1e-6; % [uT]
% field to v1 conversion for 13C
ex.B1_field = 1*1e-6; % [uT] % for SLIC 
ex.Ad.delta = 50; % [Hz] frequency to sweep
ex.Ad.phase = linspace(0,360,361*2)*pi/180; % [rad] offset from sin
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH= 1;                              % pH2 fraction (1 - 100)%
%ex.Kd = 10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa = ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd = 10;                             % [s^-1] dissociation rate for exC
%% SLIC parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.B0 = B0_field; % uT field
% rf on 13C
ex.v1 = ex.B1_field*(ex.Ss.gamma{end}/(2*pi)); % field in Hz, field in uT in []
ex.v1v = ex.v1/ex.Ss.g_gh{end};     % in [Hz] for 1H gamma!
ex.vrf = -535; % Hz resonancing frequency


%% Adiabatic frq sweep parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.Ad.T = 2; % s, total time of adiabatic frq sweep
ex.Ad.N = 10000; % number of points for the adiabatic sweep % about 5k is min
ex.Ad.time = linspace(0,ex.Ad.T,ex.Ad.N); % s time to move frequency
ex.Ad.dt = ex.Ad.time(2)-ex.Ad.time(1); % s time step
ex.Ad.field_amplification = 5; % the adiabatic filed is 2*v1*amplification*sin()
%%
ex.Yout = sabre_exC_ULF_ic_v1SWEEP_adiabatic_phase(ex);
%%
plot_all_ULF_SLIC_1D(ex.System,ex.Yout.c,ex,ex.show_c,ex.SOcStr,"Polarization")
save(ex.Folder,"ex")

%% %%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
