%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(5);
ex=Load_SABRE_System(System);

ex.Folder="out\SLIC_SHEATH_SABRE_"+System+"_B0_v1.mat";
%% change these parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
B0_field = linspace(40,60,1001)*1e-6; % [uT]
% field to v1 conversion for 13C
ex.B1_field = linspace(0,6,999)*1e-6; % [uT]
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH= 1;                              % pH2 fraction (1 - 100)%
%ex.Kd =10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa =ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd =10;                             % [s^-1] dissociation rate for exC
%% parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.timeRFv = linspace(0,100,3);          % X nuclei RF pulse time [s]
ex.B0v = B0_field; % uT field
% rf on 13C
ex.v1=ex.B1_field*(ex.Ss.gamma{end}/(2*pi)); % field in Hz, field in uT in []
ex.v1v = ex.v1/ex.Ss.g_gh{end};     % in [Hz] for 1H gamma!
ex.vrf= -535; % Hz resonancing frequency
ex.prebubble = 0.1; % s
%%
Yout = sabre_exC_ULF_SLIC_t_B0_v1(ex);
%%
ex.Yout=Yout;
plot_all_ULF_SLIC_SABRE_B0_v1(ex.System,ex.Yout.c,ex,ex.show_c,ex.SOcStr,"Polarization")
save(ex.Folder,"ex")

%% adiabatic RampDown RF pulse parameters
%ex.RampDown.B1=linspace(10, 0,1000)*1e-6; % B1 field 
%ex.RampDown.v1=ex.RampDown.B1*(ex.Sc.gamma{1}/(2*pi)); % field in Hz in 1H terms
%ex.RampDown.vrf=-(1+ex.ppmC(end))*ex.Sc.gamma{end}*ex.B0/(2*pi)+ex.offsetv*1+20;
%ex.RampDown.Time=3; % seconds
%ex.RampDown.dt=ex.RampDown.Time/length(ex.RampDown.v1); % seconds time step
% exC calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Yout = sabre_exC_ULF_SLIC_RampDown(ex);
%plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.c,ex,ex.show_c,ex.SOcStr,"Polarization")
%plot_all_ULF_SLIC_SABRE(System,Yout.c,ex,ex.show_c);


%% MOD2 calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Yout = sabre_MOD2_ULF_SLIC(ex);
%Yout = sabre_MOD2_ULF_SLIC_Q(ex);
% % plot 1D
% display("[Substrate]/[Catalyst] = "+num2str(Yout.SABRE.fs/Yout.SABRE.fc));
% for k=1:length(ex.show_s)
%     Yout.total{k}=(Yout.s{ex.show_s(k)}*Yout.SABRE.fs+Yout.c{ex.show_c(k)}*Yout.SABRE.fc)/(Yout.SABRE.fs+Yout.SABRE.fc);        
%     ex.SOallStr{k}=ex.SOcStr{ex.show_c(k)};
%     ex.SOcStr{ex.show_c(k)}
%     ex.SOsStr{ex.show_s(k)}
% end
% ex.show_all=1:length(ex.show_s);
% plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.total,ex,ex.show_all,ex.SOallStr,"(P_f*[F]+P_c*[C])/([F]+[C])")
%% plot 2D
%plot_all_ULF_SLIC_SABRE(System,Yout.s,ex,ex.show_s);
%plot_all_ULF_SLIC_SABRE(System,Yout.total,ex,ex.show_all);


%% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data.System=System;
data.Yout=Yout;
data.ex=ex;
save(ex.Folder,'data');

%% %%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
