%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(13);%5 HH-C, 13 HHP-C; 1 HHN-1 14 HHPN
ex=Load_SABRE_System(System);

ex.Folder="out\RF_SHEATH_SABRE_"+System+"_vrf_v1_time.mat";
%% change these parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%frq_offset = linspace(-30,30,61); % [Hz] offset from X spin resonance
% field to v1 conversion for 13C
ex.B1=[0.1:0.1:0.9, 1:1:200]*1e-6; % field in uT
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH = 1;                              % pH2 fraction (1 - 100)%
%ex.Kd = 10;                             % [s^-1] dissociation rate for MOD2
%ex.Wa = ex.Kd/20;                       % [s^-1] association rate for MOD2
ex.Kd = 5;                             % [s^-1] dissociation rate for exC
%% parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.B0 = 50*1e-6;                               % observation magnetic field [T]
ex.timeRFv =[100]; %           % X nuclei RF pulse time [s]
%ex.offsetv = frq_offset; % [Hz] offset from X spin resonance
% rf on 13C
ex.v1v = ex.B1*(ex.Sc.gamma{1}/(2*pi));     % in [Hz] for 1H gamma!
v0H=-(1+ex.ppmC(1))*ex.Sc.gamma{1}*ex.B0/(2*pi); % 1H frequency
v0X=-(1+ex.ppmC(end))*ex.Sc.gamma{end}*ex.B0/(2*pi); % 13C frequency
ex.vrfv = 50+v0X:-1:2*v0H;%linspace(v0X,v0H,1600);
%-(1+ex.ppmC(end))*ex.Sc.gamma{end}*ex.B0/(2*pi)+ex.offsetv; % resonancing frequency
% rf on 1H
%ex.v1v = linspace(0,60,200)/ex.Ss.g_gh{1};     % in [Hz] for 1H gamma!
%ex.vrfv= -(1+ex.ppmC(1))*ex.Sc.gamma{1}*ex.B0/(2*pi)+ex.offsetv; % resonancing frequency
ex.prebubble = 10;

%% exC calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Yout = sabre_exC_ULF_SLIC(ex);

%%
plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.c,ex,ex.show_c,ex.SOcStr,"Polarization")
%plot_all_ULF_SLIC_SABRE(System,Yout.c,ex,ex.show_c);


%% MOD2 calculate SABRE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Yout = sabre_MOD2_ULF_SLIC(ex);
%Yout = sabre_MOD2_ULF_SLIC_Q(ex);
% % plot 1D
% display("[Substrate]/[Catalyst] = "+num2str(Yout.SABRE.fs/Yout.SABRE.fc));
% for k=1:length(ex.show_s)
%     Yout.total{k}=(Yout.s{ex.show_s(k)}*Yout.SABRE.fs+Yout.c{ex.show_c(k)}*Yout.SABRE.fc)/(Yout.SABRE.fs+Yout.SABRE.fc);        
%     ex.SOallStr{k}=ex.SOcStr{ex.show_c(k)};
%     ex.SOcStr{ex.show_c(k)}
%     ex.SOsStr{ex.show_s(k)}
% end
% ex.show_all=1:length(ex.show_s);
% plot_all_ULF_SLIC_SABRE_voffset_v1(System,Yout.total,ex,ex.show_all,ex.SOallStr,"(P_f*[F]+P_c*[C])/([F]+[C])")
%% plot 2D
%plot_all_ULF_SLIC_SABRE(System,Yout.s,ex,ex.show_s);
plot_all_ULF_SLIC_SABRE(System,Yout.c,ex,ex.show_c);


%% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data.System=System;
data.Yout=Yout;
data.ex=ex;
save(ex.Folder,'data');

%% %%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
