
t=linspace(0,2000,2000); % us
T=90.3;                  % us
B10 = 1/T;               % B1 field amplitude in 1/us
y=sin(2*pi*t*B10);         % signal
sigma = 20;


%% h = 10 mm
N10=2000; % slices on sample 10 mm
x10=linspace(-5,5,N10); % mm sample hight
[y10,b10] = average_nutation(t,x10,B10,sigma);
%% h = 20 mm
N20=2*N10; % slices on sample 10 mm
x20=linspace(-10,10,N20); % mm sample hight
[y20,b20] = average_nutation(t,x20,B10,sigma);
%% h = 30 mm
N30=3*N10; % slices on sample 10 mm
x30=linspace(-15,15,N30); % mm sample hight
[y30,b30] = average_nutation(t,x30,B10,sigma);


subplot(3,2,1)
plot(t,y10)
xlabel("Excitation pulse length (us)")
ylabel("signal (norm.)")

subplot(3,2,3)
plot(t,y20)
xlabel("Excitation pulse length (us)")
ylabel("signal (norm.)")

subplot(3,2,5)
plot(t,y30)
xlabel("Excitation pulse length (us)")
ylabel("signal (norm.)")

subplot(3,2,2)
plot(x10,b10)
xlabel("height (mm)")
ylabel("B1 field (norm. on mean)")

subplot(3,2,4)
plot(x20,b20)
xlabel("height (mm)")
ylabel("B1 field (norm. on mean)")

subplot(3,2,6)
plot(x30,b30)
xlabel("height (mm)")
ylabel("B1 field (norm. on mean)")

% std in % : homogeneity measures
std(b10)/mean(b10)*100
std(b20)/mean(b20)*100
std(b30)/mean(b30)*100

function [y,B1]=average_nutation(t,x,B10,sigma)
    y=0;
    N10=length(x);
    B1 = exp(-x.^2/(2*sigma^2));
    B1 = B10*B1/mean(B1); % make the average equal to B10;
    for n=1:N10    
        y=y+sin(2*pi*t*B1(n));         % average signal across the sample
    end
    y=y/max(y);
    B1=B1/mean(B1);
end