%% T1(B)
B0=10;
B1=1e-3;
Bfd = logspace(log10(B1),log10(B0),200);
T1_0=3;
T1_10=3;
T1fd = T1_0+(T1_10-T1_0)*(Bfd)/10;
subplot(3,1,1)
plot(Bfd,T1fd)
xlabel("Magnetic field")
ylabel("T1 s")


%% x(time)

%% B(x)

%% B(time)
tfs=1;
t=linspace(0,tfs,1000);
dt=t(2)-t(1);
Bfs_up=B1+t.^2/tfs^2*(B0-B1);
Bfs_dn=flip(Bfs_up);

subplot(3,1,2)
plot(t,Bfs_dn)
ylabel("Magnetic field")
xlabel("time s")

%% field cycling

Mic=-1; % initial condition
vd=linspace(0,60,100);


M0=1; % equilibrium at B0

M=Mic;
Mfs1=zeros(1,length(t));
for it=1:length(t)
    [B,T1]=find_BT1(Bfs_dn(it),Bfd,T1fd);
    R1=1/T1;
    M=M-R1*dt*(M-M0*B/B0);
    Mfs1(it)=M;
end
%subplot(2,1,1)
%plot(t,Mfs1)

Mic2=M;    % second initial condition at low field
M02=M0*B/B0;
Mvd=zeros(1,length(vd));

for ivd=1:length(vd)        
    %exp(Lt)*(Mic-M0) + M0
    M=exp(-R1*vd(ivd))*(Mic2-M02)+M02;

    Mfs2=zeros(1,length(t));
    for it=1:length(t)
        [B,T1]=find_BT1(Bfs_up(it),Bfd,T1fd);
        R1=1/T1;
        M=M-R1*dt*(M-M0*B/B0);
        %Mfs2(it)=M;
    end
    %subplot(2,1,2)
    %plot(t,Mfs2)
    Mvd(ivd)=M;
end
subplot(3,1,3)
plot(vd,Mvd)
xlabel("vd s")
ylabel("Magnetization z")




function [B,T1]=find_BT1(Bfs_up,Bfd,T1fd)
    [m,n]=min(abs(Bfs_up-Bfd));
    T1=T1fd(n);
    B=Bfd(n);
end




