function ysim=function_coherent_SHEATH_SABRE_rep_tp(Kd,KdWa_r,JHH,JNH1,JNH2,Tp)
%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%rep*ntp*ntd
%100*3*2 = 4s
%100*30*20 = 244 s = 4 min
%100*150*200 = 16055 s = 267 min = 4.5 h
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Systems{1}="HHN-1";
Systems{2}="HHNN-2";
Systems{3}="HHN-1-var";

System=Systems{3};
ex=Load_SABRE_System(System,JHH,JNH1,JNH2);
if KdWa_r<1
    KdWa_r=1;
end
%% kinetic parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.fpH= 1;                              % pH2 fraction (1 - 100)%
ex.Kd = Kd;                             % [s^-1] dissociation rate
ex.KdWa_r = KdWa_r;                         % Kd to Wa ratio
ex.Wa = ex.Kd/ex.KdWa_r;                       % [s^-1] association rate
%% magnetic fields %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.Bpv=0.5*1e-6;    % polarization external magnetic field, T
ex.Bd=30e-6;   % delay/storage external magnetic field, T
%% time grid %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.tpv=Tp*1e-3; % s
ex.TimePol=90; % total polarization time [s]
%ex.tpv=linspace(0,1000,1000)'*1e-3; % polarization time, s
ex.td=200*1e-3; % refreshing time, s
ex.rep=500;                      % repetitions
%% calculate pulsed SABRE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.Yout = pulsed_SABRE_tp(ex);


n=round(ex.TimePol./(ex.tpv+ex.td))';
ysim = ex.Yout;
linidx = sub2ind(size(ysim), 1:size(ysim,1), n);                 % Linear Index    
ysim = ysim(linidx)';
ysim = ysim/max(ysim);
%%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
