function rM = ESOTHERICn1n2n3(r0,H0,tau1,tau2,tau3,nRef,S,eH,eC)    
    %ESOTHERIC
    %1H%__(90)Y-t1-(180)X-t1-(90)mY-t2-(180)X-t2-(90)Y-t1-(180)X-t1-
    % X%_______-t1-(180)X-t1-______-t2-______-t2-(90)Y-t1-(180)X-t1-FID
    t1=tau1/(2*nRef(1));
    t2=tau2/(2*nRef(2));
    t3=tau3/(2*nRef(3));

    rM=r0. RotationSuperOperator(pi/2,'Y',S,eH);    
    %3
    for k=1:nRef(1)
        [X1,Y1,rM]=rM. EvolutionConstH(H0,t1,[]);
        %4
        rM=rM.RotationSuperOperator(pi,'X',S,[eH, eC]);    
        %5
        [X2,Y2,rM]=rM.EvolutionConstH(H0,t1,[]);      
    end
    %6
    rM=rM.RotationSuperOperator(pi/2,'-Y',S,eH);    
    %7    
    for k=1:nRef(2)
        [X3,Y3,rM]=rM.EvolutionConstH(H0,t2,[]);
        %8        
        rM=rM.RotationSuperOperator(pi,'X',S,eH);    
        %9            
        [X4,Y4,rM]=rM. EvolutionConstH(H0,t2,[]);    
    end
    %10
    rM=rM.RotationSuperOperator(pi/2,'Y',S,eH);
    rM=rM.RotationSuperOperator(pi/2,'X',S,eC);        
    %11           
    for k=1:nRef(3)
        [X5,Y5,rM]=rM. EvolutionConstH(H0,t3,[]);   
        %12
        rM=rM.RotationSuperOperator(pi,'X',S,[eH, eC]);    
        %13
        [X6,Y6,rM]=rM. EvolutionConstH(H0,t3,[]);    
    end
end

