function rM = Kadlecek2b(r0,H0,tau1,tau2,S,eH,eC,ex)    
% https://www.sciencedirect.com/science/article/pii/S1631070505000514   
    echoes=ex.Kadlecek2b.echoes;     
    t1=tau1/(2*echoes);
    t2=tau2/(2*echoes);
    t3=ex.Kadlecek2b.t3/(2*echoes);    
    t4=ex.Kadlecek2b.t4/(2*echoes);
    rM=r0;        


    %1-1    
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t1,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH,eC]);           
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t1,[]);
    end
    rM=rM.RotationSuperOperator(pi,'X',S,[eH]); % eH or eC      

    %2-1
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t2,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH,eC]);           
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t2,[]);
    end
    rM=rM.RotationSuperOperator(pi,'X',S,[eH]); % eH or eC          

    %3-1
    for k3=1:ex.Kadlecek2b.n3        
        for k=1:echoes
            [X1,Y1,rM]=rM.EvolutionConstH(H0,t3,[]);    
            rM=rM.RotationSuperOperator(pi,'X',S,[eH,eC]);        
            [X2,Y2,rM]=rM.EvolutionConstH(H0,t3,[]);      
        end
        rM=rM.RotationSuperOperator(pi,'X',S,[eH]);        
    end
       
    %4-1
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t4,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH, eC]);        
        [X2,Y2,rM]=rM.EvolutionConstH(H0,t4,[]);      
    end
    rM=rM.RotationSuperOperator(pi/2,'Y',S,[eC]);
    
    %4-2
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t4,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH, eC]);        
        [X2,Y2,rM]=rM.EvolutionConstH(H0,t4,[]);      
    end
    rM=rM.RotationSuperOperator(pi,'X',S,[eH]);
    
    %3-2
    for k3=1:ex.Kadlecek2b.n3
        for k=1:echoes
            [X1,Y1,rM]=rM.EvolutionConstH(H0,t3,[]);    
            rM=rM.RotationSuperOperator(pi,'X',S,[eH, eC]);        
            [X2,Y2,rM]=rM.EvolutionConstH(H0,t3,[]);      
        end
        rM=rM.RotationSuperOperator(pi,'X',S,[eH]);
    end

    %2-1
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t2,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH,eC]);           
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t2,[]);
    end
    rM=rM.RotationSuperOperator(pi,'X',S,[eH]); % eH or eC  
   
    %1-1
    for k=1:echoes
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t1,[]);    
        rM=rM.RotationSuperOperator(pi,'X',S,[eH,eC]);           
        [X1,Y1,rM]=rM.EvolutionConstH(H0,t1,[]);
    end
    rM=rM.RotationSuperOperator(pi/2,'X',S,[eC]); % eH or eC  

end

