function y = Load_INEPT_simulation(A,B,x)
    %% Name of the folder which contains the simulations files %%%%%%%%%%%%%%%% 
    System_type{1} = "HHN-1"     ;
    System_type{2} = "HHNN-2"    ;
    System_type{3} = "HHC-1"     ;
    System_type{4} = "HHHC-1"    ;
    System_type{5} = "HH-HHHC-1" ;

    INEPT_types{1} = 'SABREINEPT'                 ;
    INEPT_types{2} = 'SABREINEPT_Multi_Kd'        ;
    INEPT_types{3} = 'SABREINEPTplus'             ;
    INEPT_types{4} = 'SABREINEPTplus_Multi_Kd'    ;
    INEPT_types{5} = 'SABREINEPT2'                ;
    INEPT_types{6} = 'SABREINEPT2_Multi_Kd'       ;
    INEPT_types{7} = 'SABREINEPT2tev'             ;
    INEPT_types{8} = 'SABREINEPT2tev_Multi_Kd'    ;

    System     = System_type{2}    ;
    INEPT_type = INEPT_types{8}    ; 
    ex.Folder  = "out\"+System+"\"+INEPT_type+"\"+INEPT_type+"_"             ; %
    Kd_range   = 8:0.1:70;
    [~,id]= min(abs((Kd_range-B)));
    
    tempsimulation = load(ex.Folder+Kd_range(id)+'.csv','out')   ; % temporarily 
     switch INEPT_type
         case {'SABREINEPT_Multi_Kd','SABREINEPT2tev_Multi_Kd'}  
                ynorm  = tempsimulation(:,2)/max(tempsimulation(:,2)); 
         case 'SABREINEPTplus_Multi_Kd'   
                tempy  = -tempsimulation(:,2);
                ynorm  = tempy/max(tempy)    ;
     end 
%       switch INEPT_type
%          case {'SABREINEPT_Multi_Kd','SABREINEPTplus_Multi_Kd'}  
%                 y = A*ynorm(1:length(x)); 
%          case 'SABREINEPT2tev_Multi_Kd'  
%                 y =ynorm(1:length(x))+exp(-A*x);
%       end 
  y = A*ynorm(1:length(x));
end