function [spec] = SABRE_mod1_FID(ex,rC0,spec)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    rC=rC0;
    %% initial spin state of the Ir-complex and substrate  
    if ~isempty(spec.Excitation.C)
        rC0=rC0.RotationSuperOperator(spec.Excitation.Pulse,spec.ph1,ex.Sc,spec.Excitation.Spins);
    end
                          
    NC2=ex.Sc.Nstates^2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% relaxation superoperator of the Ir-complex and substrate
    RsC=RLFF_EN(ex.Sc,ex.T1C);        
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% calculate SABRE FID
    B=spec.B0;
    % delay     
    HcB=2*pi*HZJij(ex.Sc,ex.ppmC,ex.JC,B,"full");
    SABRE=SABRE_exC_matrix(rC0,...                        
                            ex.Sc,HcB,RsC,...
                            ex.Sh,...
                            ex.fpH,ex.Kd);    
    spec.Ytc=zeros(spec.TD,length(ex.SOcFID));
    spec.DTime = 1 / spec.SW; % [Hz]
    spec.AQTime= (0:1:spec.TD-1)'*spec.DTime;        
    vec0=mtz2vec(rC0.val)/trace(rC0.val);    
    for it=1:spec.TD
        if mod(it,100)==0
            display(it/spec.TD*100);
        end
        t=spec.AQTime(it); % current time        
        rC.val=vec2mtz(expm(SABRE.A*t)*vec0);        
        spec.Ytc(it,:)=(Amplitudes(rC,ex.SOcFID));
    end
    %% FID
    spec.FID_spins=(spec.Ytc(:,1:ex.Sc.N));        
    spec.FID = sum(spec.FID_spins,2);        
    %ex.Sc.SpinName=="1H"
    %spec.FID_1H = (spec.Ytc(:,1:2) + 1i*spec.Ytc(:,ex.Sc.N+1:ex.Sc.N+1+2)) * SABRE.fc;
    %spec.FID_1H = sum(spec.FID_1H,2);
    %spec.FID_15N = (spec.Ytc(:,3:end)) * SABRE.fc;
    %spec.FID_15N = sum(spec.FID_15N,2) + spec.FIDs;
    %% spectrum
    spec.spec = fftshift(fft(spec.FID),1); %FFT in indirect dimension        
    %spec.spec_1H = fftshift(fft(spec.FID_1H),1); %FFT in indirect dimension
    %spec.spec_15N = fftshift(fft(spec.FID_15N),1); %FFT in indirect dimension
    spec.FRQ = linspace(-spec.SW/2,spec.SW/2,spec.TD); %indirect frequency domain
end

