function S = Substrate_concentration(kd,ka,S0,Ir0)
    
    a  = 1                                   ;
    b  = kd/ka-S0+3*Ir0                      ;
    c  = (2*Ir0-S0)*kd/ka                    ;
    D  = (b^2-4*a*c)^0.5                     ;
    S1 = (-b-D)/2                            ;
    S2 = (-b+D)/2                            ;    
    S  = max([S1 S2])                        ;
    if S<0
        error('S<0')
    elseif (S>S0)
        error('S>S0')
    elseif (imag(S)~=0)
        error('S is not real')            
    end
end