function [kd, errorkd, kaprime] = kd_EXSY(mixing_time,CsS2,CsS2S2,S2CsS2,S)

%%% n is the reference of the data in every list
dmix          = mixing_time                                                ; % mixing time in second
IS            = S                                                          ; % Integral of IS       or I free-free
ICsS2         = CsS2                                                       ; % Integral of ICsS2     or I eq-eq
ICsS2S2       = CsS2S2                                                     ; % Integral of ICsS2->S2 or I eq-free
IS2CsS2       = S2CsS2                                                     ; % Integral of IS2->CsS2 or I free-eq
Icross        = 0.5*(ICsS2S2 + IS2CsS2)                                    ; % Integral of Icross
errorIS       = 0.02*IS                                                    ; % Error of Ifree Integrals 2%
errorICsS2    = 0.02*ICsS2                                                 ; % Error of Ieq Integrals 2%
errorIcross   = 0.1*Icross                                                 ; % Error of Icross Integrals 1%


         
            K       = 2*(IS + Icross)/(ICsS2 + Icross)                     ; % this section to calculate Kd
            c       = (2 + K)                                              ;
            aa      = K*ICsS2+2*IS+c*Icross                                ;
            bb      = K*ICsS2+2*IS-c*Icross                                ;
            kd      = (2*K/(c*dmix))*log(aa/bb)                            ;
            kaprime = kd/K                                                 ;
           
        
            Kf      = 2*(IS*1.0001 + Icross)/(ICsS2 + Icross)              ; % this section to help calculate error of Ifree
            c       = (2 + Kf)                                             ;
            aa      = Kf*ICsS2+2*IS*1.0001+c*Icross                        ;
            bb      = Kf*ICsS2+2*IS*1.0001-c*Icross                        ;
            kdf     = (2*Kf/(c*dmix))*log(aa/bb)                           ;
            
            Ke      = 2*(IS + Icross)/(ICsS2*1.0001 + Icross)              ; % this section to help calculate error of Ieq
            c       = (2 + Ke)                                             ;
            aa      = Ke*ICsS2*1.0001+2*IS+c*Icross                        ;
            bb      = Ke*ICsS2*1.0001+2*IS-c*Icross                        ;
            kde     = (2*Ke/(c*dmix))*log(aa/bb)                           ;
            
            Kcross  = 2*(IS + Icross*1.0001)/(ICsS2 + Icross*1.0001)       ; % this section to help calculate error of Icross
            c       = (2 + Kcross)                                         ;
            aa      = Kcross*ICsS2+2*IS+c*Icross*1.0001                    ;
            bb      = Kcross*ICsS2+2*IS-c*Icross*1.0001                    ;
            kdcross = (2*Kcross/(c*dmix))*log(aa/bb)                       ;
            
            dkfdIf  = (kdf - kd) / (IS*0.0001)                             ; % error of Ifree
            dkedIe  = (kde - kd) / (ICsS2*0.0001)                          ; % error of Ieq
            dkcrossdIcross = (kdcross - kd) / (Icross*0.0001)              ; % error of Icross
                  
            errorkd = sqrt(((dkfdIf)^2*(errorIS)^2) + ((dkedIe)^2*(errorICsS2)^2) + ((dkcrossdIcross)^2*(errorIcross)^2)); % error of kd
            
            fprintf("results: \n")
            fprintf("Model has kd = %.2f ± %.2f s-1 ,ka' = %.2f s-1.mmol/L \n",kd,errorkd,kaprime)
            
end