function y = load_ESOTHERIC_simulation(A,B,x)
    %% Name of the folder which contains the simulations files %%%%%%%%%%%%%%%% 
    System_type{1} = "HHN-1"     ;
    System_type{2} = "HHNN-2"    ;
    System_type{3} = "HHC-1"     ;
    System_type{4} = "HHHC-1"    ;
    System_type{5} = "HH-HHHC-1" ;

    ESOTHERIC_types{1} = 'SABREESOTHERIC'                 ;
    ESOTHERIC_types{2} = 'SABREESOTHERIC_2D_TA_TB'        ;
    ESOTHERIC_types{3} = 'SABREESOTHERIC_2D_TA_vdList'    ;
    ESOTHERIC_types{4} = 'SABREESOTHERIC_2D_TB_vdList'    ;
    ESOTHERIC_types{5} = 'SABREESOTHERIC_TAvd_Multi_Kd'   ;
    ESOTHERIC_types{6} = 'SABREESOTHERIC_TBvd_Multi_Kd'   ;
    ESOTHERIC_types{7} = 'SABREESOTHERIC_tev'             ;
    ESOTHERIC_types{8} = 'SABREESOTHERICtev_Multi_Kd'     ;

    System             = System_type{2}                   ;
    ESOTHERIC_type     = ESOTHERIC_types{5}               ;  
    ex.Folder          = "out\"+System+"\ESOTHERIC\"+ESOTHERIC_type+"\"+ESOTHERIC_type+"_"      ;
    Kd_range   = 10:0.1:80;
    [~,id]= min(abs((Kd_range-B)));
    
    tempsimulation = load(ex.Folder+Kd_range(id)+'.csv','out')   ; % temporarily 
     switch INEPT_type
         case {'SABREINEPT_Multi_Kd','SABREINEPT2tev_Multi_Kd'}  
                ynorm  = tempsimulation(:,2)/max(tempsimulation(:,2)); 
         case 'SABREINEPTplus_Multi_Kd'   
                tempy  = -tempsimulation(:,2);
                ynorm  = tempy/max(tempy)    ;
     end 
%       switch INEPT_type
%          case {'SABREINEPT_Multi_Kd','SABREINEPTplus_Multi_Kd'}  
%                 y = A*ynorm(1:length(x)); 
%          case 'SABREINEPT2tev_Multi_Kd'  
%                 y =ynorm(1:length(x))+exp(-A*x);
%       end 
  y = A*ynorm(1:length(x));
end