function ex = get_INEPTmap(ex)
ex.H0    = 2*pi*HZJij(ex.S,ex.PPM,ex.J,ex.B0,"full")                       ;
[Q,E0]   = eig(full(ex.H0))                                                ;
r0       = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2)         ; % select spins
r0       = r0.RemoveCoherences(Q)                                          ; 

%r0= DensityMatrix(ex.S.SSzznorm(ex.n1,ex.n2));
%r0 = r0.RemoveCoherences(Q);


Ymap.X   = zeros(length(ex.tau1v),length(ex.tau2v))                        ; % switch tau1 and tau2
Ymap.Y   = zeros(length(ex.tau1v),length(ex.tau2v))                        ; % switch tau1 and tau2
Ymap.Z   = zeros(length(ex.tau1v),length(ex.tau2v))                        ; % switch tau1 and tau2

fprintf("progress: %3.0f%%\n", 0)                
    for itau1 = 1:length(ex.tau1v)                                         
        fprintf("\b\b\b\b\b%3.0f%%\n", [itau1/length(ex.tau1v)*100])                
        tau1 = ex.tau1v(itau1)                                             ;    
        for itau2 = 1:length(ex.tau2v)        
        tau2 = ex.tau2v(itau2)                                             ;
        switch ex.SOT
            case "phINEPTplus"
                rM = phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,    ex.eC)  ;  
            case "o10sel90_phINEPTplus"
                rM = o10sel90_phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC);
            case "o01sel90_phINEPTplus"
                rM = o01sel90_phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC);
            case "o11sel90_phINEPTplus"
                rM = o11sel90_phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC);
            case "sel90_phINEPTplus"
                rM = sel90_phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC);
            case "osel90_phINEPTplus"
                rM = phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH.sel,    ex.eC);                     
            case "l10sel90_phINEPTplus"
                rM = l10sel90_phINEPTplus(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC);  
                
            case "ESOTHERIC"
                rM = ESOTHERIC(r0,ex.H0,tau1,tau2,tau1,ex.S,ex.eH,    ex.eC);                 
                %ex.Delta1=1e3/(2*ex.J(1,3)); % ms
                %ex.Delta2=1e3/(2*ex.J(1,2)); % ms                
            case "ESOTHERICn1n2n3"
                rM = ESOTHERICn1n2n3(r0,ex.H0,tau1,tau2,tau1,ex.nRef,ex.S,ex.eH,    ex.eC); 
                ex.Delta1=1e3/(2*ex.J(1,3)); % ms                
                ex.Delta2=1e3/(2*ex.J(1,2)); % ms
            case "ESOTHERICn1n2n3_CP"
                rM = ESOTHERICn1n2n3_CP(r0,ex.H0,tau1,tau2,tau1,ex.nRef,ex.S,ex.eH,ex.eC); 
                ex.Delta1=1e3/(2*ex.J(1,3)); % ms                
                ex.Delta2=1e3/(2*ex.J(1,2)); % ms
            case "Goldman"
                J13=ex.J(1,3);
                J23=ex.J(2,3);
                b=ex.J(1,2);
                a=abs((J13-J23)/2);                
                Om=sqrt(a^2+b^2);
                TG=atan(b/a);
                
                t034G=1/(2*Om);
                ex.Goldman.TG=TG;                
                ex.Goldman.tau034=t034G;
                ex.Goldman.betas=zeros(1,ex.Goldman.n2);
                ex.Goldman.N = ((b^2-a^2+1i*2*a*b)/(Om^2))^(ex.Goldman.n1+1);
                ex.Goldman.N1 = real(ex.Goldman.N);
                ex.Goldman.N2 = imag(ex.Goldman.N);
                ex.Goldman.t1G=1/(2*pi*Om)*acos((a^2-b^2)/(2*a*b)*(a*ex.Goldman.N2+b*ex.Goldman.N1)/(b*ex.Goldman.N2-a*ex.Goldman.N1));

                ex.Goldman.M1 = (a*ex.Goldman.N2+b*ex.Goldman.N1)/(2*b);
                
                ex.Goldman.M2 = -abs((b*ex.Goldman.N2-a*ex.Goldman.N1)/(2*Om) * sin(2*pi*Om*ex.Goldman.t1G));
                
                ex.Goldman.t2G=1/(2*pi*Om)*acos(a^2*ex.Goldman.M2/(a^2*ex.Goldman.M2^2+Om^2*ex.Goldman.M1^2));
                
                for k2=1:ex.Goldman.n2
                    b1=(sin(2*TG))^2*(cos(2*TG))^(2*(k2));
                    b2=1-(cos(2*TG))^(2*(k2));
                    beta=atan(sqrt(b1/b2));
                    if TG>pi/180*60
                        beta=(-1)^(k2-1)*beta;                   
                    end
                    ex.Goldman.betas(k2)=beta;
                end
                % errors in Bar: 
                % -1 for TG>60
                % in beta angle should be k2 not k2-1!
                % in diagram refocusing pulses are missing on 1H!
                % the t2G is not correct, do not know the right solution
                rM = GOLDMAN(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC,ex);                 
                
            case "Kadlecek2b"
                J13=ex.J(1,3);
                J23=ex.J(2,3);
                b=ex.J(1,2);
                a=abs((J13-J23)/2);                
                Om=sqrt(a^2+b^2);
                TG=atan(b/a);
                TG_K=atan(a/b);
                
                ex.Kadlecek2b.TG = TG;
                ex.Kadlecek2b.TGdegree = TG/pi*180;
                n=ex.Kadlecek2b.n3;
                ex.Kadlecek2b.t1=1/(2*pi*Om)*acos(1-(sqrt(2)*cos(TG_K)-sin(TG_K)*cos(2*n*TG_K)-sin(2*n*TG_K)*sqrt(2-(sin(TG_K))^2))/(sqrt(2)*sin(TG_K)*sin(2*TG_K)));                                
                ex.Kadlecek2b.t2=1/(2*pi*Om)*(pi+atan((sin(TG_K)*sin(2*pi*Om*ex.Kadlecek2b.t1))/(sin(2*TG_K)*cos(TG_K)-cos(2*pi*Om*ex.Kadlecek2b.t1)*sin(TG_K)*cos(2*TG_K))));

                ex.Kadlecek2b.t3=1/(2*Om);                                
                ex.Kadlecek2b.t4=atan(csc(TG))/(2*pi*Om);

                ex.Kadlecek2b.t4_K=atan(-sec(TG_K))/(2*pi*Om);
                
                
                rM = Kadlecek2b(r0,ex.H0,tau1,tau2,ex.S,ex.eH,ex.eC,ex); 
                % errors in Bar:
                % t3 was missing in the table, t4 is wrong and tot time is
                % wrong

            case "SPESOTHERIC"
                rM = SPESOTHERIC(r0,ex.H0,tau1,tau2,tau1,ex.S,ex.eH,    ex.eC); 
            case "SEPP"
                rM = SEPP(r0,ex.H0,tau1,ex.S,ex.eH); 
            case "SEPPINEPT+"
                t0 = ex.t0;
                rM = SEPPINEPTplus(r0,ex.H0,t0,tau2,tau1,ex.S,ex.eH,ex.eC); 
            case "SEPPINEPT+others"
                t0=ex.t0;
                rM = SEPPINEPTplusothers(r0,ex.H0,t0,tau2,tau1,ex.S,ex.eH,ex.eC); 
                
            otherwise
                error
        end
        Ymap = get_Amplitudes(rM,ex.SOs,Ymap,itau2,itau1)                  ; % switch tau1 and tau2 i added t in addition please take it in consideration to take it out
        end
    end
    ex.Amplitudes = Ymap                                                   ;
end

