function Ymap = get_INEPTmap1DFA(ex,INEPT_type)
ex.H0 = 2*pi*HZJij(ex.S,ex.ChSh,ex.J,ex.B0,"full");
[Q,E0] = eig(full(ex.H0));
r0 = DensityMatrix('100%_SingletSpinOrder',ex.S,ex.n1,ex.n2);%select spins
r0 = r0.RemoveCoherences(Q); 
ex.FAHv = ex.FAH*pi/180;
ex.FACv = ex.FAC*pi/180;

if length(ex.FAHv)~=length(ex.FACv)
    error("H and C lengths must be the same")
end

Ymap.X=zeros(length(ex.FACv),1);
Ymap.Y=zeros(length(ex.FACv),1);
Ymap.Z=zeros(length(ex.FACv),1);

    for it2=1:length(ex.FAHv)
        it2/length(ex.FAHv)*100
        FAH=ex.FAHv(it2);                   
        FAC=ex.FACv(it2);
        switch INEPT_type                            
            case "ESOTHERIC_L_FA_1"
                rM = ESOTHERIC_L_FA_1 (r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC);                   
            case "ESOTHERIC_L_FA_NE"
                rM = ESOTHERIC_L_FA_NE(r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC,ex.NE);   
            case "ESOTHERIC_L_CompFA_NE"
                rM = ESOTHERIC_L_CompFA_NE(r0,ex.H0,ex.t1,ex.t2,ex.t3,ex.S,FAH,FAC,ex.eH,ex.eC,ex.NE);   
            otherwise
                error                
        end
        Ymap = get_Amplitudes(rM,ex.SOs,Ymap,1,it2);
    end
end

