function [Yts,rS,rC] = sabre_tB_single(ex)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% nonpolorized initial spin state of the Ir-complex and substrate
    rC0=DensityMatrix(ex.Sc.U);
    rS0=DensityMatrix(ex.Ss.U);
    rS=rS0;
    rC=rC0;
            
    NS2=ex.Ss.Nstates^2;
    NC2=ex.Sc.Nstates^2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% relaxation superoperator of the Ir-complex and substrate
    RsC=RLFF_EN(ex.Sc,ex.T1C);
    RsS=RLFF_EN(ex.Ss,ex.T1S);    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% calculate SHEATH-SABRE experiment     
        B=ex.B;
        % delay 
        HsB=2*pi*HZJij(ex.Ss,ex.ppmS,ex.JS,B,"full");
        HcB=2*pi*HZJij(ex.Sc,ex.ppmC,ex.JC,B,"full");
        SABRE=SABRE_MOD2_matrix(rC0,...
            ex.Ss,HsB,RsS,...
            ex.Sc,HcB,RsC,...
            ex.Sh,...
            ex.fpH,ex.Wa,ex.Kd);
        
        t=ex.t;
        SAt=expm(SABRE.A*t);            
        vecS0=mtz2vec(rS0.val)/trace(rS0.val)*SABRE.fs;
        vecC0=mtz2vec(rC0.val)/trace(rC0.val)*SABRE.fc;
        vec=[vecS0' vecC0']';                                      
        vec=SAt*vec; 
        rS.val=vec2mtz(vec(1:NS2))/SABRE.fs;
        rC.val=vec2mtz(vec(NS2+1:NS2+NC2))/SABRE.fc;
        Yts=Amplitudes(rS,ex.SOs);                                                                 
end

