% here is an example of simulations of 1D NMR spectrum using Bloch class
clear all
%close all 

tic
% 90y - FID
p                    = LoadPath()                                          ;

% system parameters and spins

Spec.System          = SPINS_Systems(4)                                    ; % 1 = A, 2 = AB, 3 = ABC, 4 = CsS2->S2
[Spec.T1,Spec.T2,Spec.C,Spec.wz,Spec.K] = Load_SPINS_Systems(Spec.System)  ;
Spec.M               = SPINS(Spec.T1,Spec.T2,Spec.C)                       ;

%% sepctral parameters

Spec.lb              = 2                                                   ; % linebroadening [Hz]
Spec.sw              = 2000                                                ; % Sampling frequency                    
Spec.td              = 2^15                                                ; % Length of signal
Spec.si              = Spec.td*2                                           ; % Length of signal after zerofilling
Spec.time2relax      = 100*max(Spec.T1)                                    ;
Spec.Integral_width  = 20                                                  ; % Hz
Spec.p1              = 90                                                  ; % excitation angle in degrees
Spec.ph0             = 0                                                   ; % phase 0 in degrees
Spec.ph1             = "Y"                                                 ; % excitation phase in X,Y,-X,-Y
%% calculate spectrum
% 90-Y rotation
Spec                 = Spec.M. zg(Spec)                                    ; % Calculate Evolution


%% calculate and plot spectrum

Spec                 = Spec.M.Spectrum(Spec,1)                             ; % calculate spectrum
Spec.M.Plot_Spectrum(Spec,1)                                               ; % plot spectrum
toc
%% analyze integrals

% for id_spin = 1:Spec.M.N
%     Spec.Integrals_range(id_spin,:) = Spec.wz(id_spin)/(2*pi)+[-1,1]*Spec.Integral_width/2                ;
%     [Spec.Integrals(id_spin,1),~,~] = D1_integral(Spec.Proc.frq,Spec.Proc.Spectrum,Spec.Integrals_range(id_spin,:)) ;
%     fprintf("integral id %.0f \n",id_spin)                                 ;
%     fprintf("range %.4f %.4f \n", Spec.Integrals_range(id_spin,:))         ;
%     fprintf("value %f \n",Spec.Integrals(id_spin))                         ;
% end



