tic
clear all
close all

p              = LoadPath()                                                ;
% system parameters

Spec.System    = SPINS_Systems(4)                                          ; % 1 = A, 2 = AB, 3 = ABC, 4 = CsS2->S2
[Spec.T1,Spec.T2,Spec.C,Spec.wz,Spec.K] = Load_SPINS_Systems(Spec.System)  ;

%declaration of spins

Spec.M         = SPINS(Spec.T1,Spec.T2,Spec.C)                             ; 
% evolution during timeFID

% spectral parameters: direct dimension
Spec.sw        = 500                                                       ; % Sampling frequency                    
Spec.td        = 2^9                                                       ; % Length of signal
Spec.si        = Spec.td*4                                                 ; % Length of signal after zerofilling

% spectral parameters: indirect dimension
Spec.sw1       = 500                                                       ; % Sampling frequency                    
Spec.td1       = 2^9                                                       ; % Length of signal
Spec.si1       = Spec.td1*4                                                ; % add                                                    
Spec.o1        = Spec.wz(1)                                                ; % rotating frame of reference during SOT


% additional sequence parameters
Spec.d1        = 10                                                        ; % delay before sequence
Spec.d8        = 0.05                                                      ; % Mixing time
Spec.ds        = 32                                                        ; % Dummy scans

% calculate experiment
Spec.ns        = 1                                                         ; % values between 1 and 16 for phase cycling
Spec           = Spec.M.noesyph(Spec)                                      ; % Calculate EXSY sequence with phase cycling


%% Plot 2D spectrum 
Spec.lb        = 10                                                        ; % Linebroadening [Hz]
Spec.lb1       = 10                                                        ; % Linebroadening [Hz]
Spec           = Spec.M.Spectrum2D(Spec)                                   ; % Calculate spectrum
%% plot
Spec.M.Plot_Spectrum2D(Spec)                                               ; % Plot spectrum

%% analyze integrals
Spec.Integral_width  = 50                                                  ; % Half width for the spectrum integration Hz
Spec.Peaks           = Spec.wz/(2*pi)                                      ; % This peaks we will integrate
[Spec.Integrals]     = D2_integrals(Spec.frq,Spec.frq1,abs(Spec.Spectrum),Spec.Peaks,Spec.Integral_width); % specify your integrations area
kd_EXSY(Spec.d8,Spec.Integrals.rect(1,1),Spec.Integrals.rect(1,2),Spec.Integrals.rect(2,1),Spec.Integrals.rect(2,2)) ;% Calculate kd
toc

%% save
% out       = Spec.Integrals.rect                                            ;
% save(sprintf("out_EXSY/EXSY_integrals_rect_dmix%.2fms.txt",[Spec.d8*1e3]),"out","-ASCII");
% out       = [Spec.Integrals.range.lin Spec.Integrals.lin]                  ;
% names     = ["dirL (Hz)","dirR (Hz)","indL (Hz)","indR (Hz)","integral"]   ;
% out       = [names',out']'                                                 ;
% writematrix(out,sprintf("out_EXSY/EXSY_integrals_lin_dmix%.2fms.txt",[Spec.d8*1e3]),'Delimiter','tab')
% 
% % save all SEXY parameters
% save(sprintf("out_EXSY/EXSY_experiment_dmix%.2fms.txt",[Spec.d8*1e3]),"Spec")




