tic
clear all
close all

p              = LoadPath()                                                ;
% system parameters

Spec.System    = SPINS_Systems(4)                                          ; % 1 = A, 2 = AB, 3 = ABC, 4 = CsS2->S2
[Spec.T1,Spec.T2,Spec.C,Spec.wz,Spec.K] = Load_SPINS_Systems(Spec.System)  ;

%declaration of spins

Spec.M         = SPINS(Spec.T1,Spec.T2,Spec.C)                             ; 
% evolution during timeFID

% spectral parameters: direct dimension
Spec.sw        = 3280.840                                                  ; % Sampling frequency                    
Spec.td        = 2^11                                                      ; % Length of signal
Spec.si        = Spec.td*1                                                 ; % Length of signal after zerofilling

% spectral parameters: idirect dimension
Spec.sw1       = 3280.840                                                  ; % Sampling frequency                    
Spec.td1       = 2^7                                                       ; % Length of signal
Spec.si1       = Spec.td1*16                                               ; % add                                                    


% additional sequence parameters
Spec.d1        = 3+0.31                                                    ; % delay before sequence
Spec.vdd8      = linspace(0.5,0.5,1)                                       ; % Mixing time
Spec.ds        = 16                                                        ; % Dummy scans
Spec.o1        = 0                                                         ; % rotating frame of reference during SOT

% calculate experiment
Spec.ns              = 8                                                   ; % values between 1 and 16 for phase cycling
Spec.ph0             = 90                                                  ; % zero order phase correction
Spec.ph1             = -180                                                ; % First order phase correction
Spec.Integral_width  = 40                                                  ; % Half width for the spectrum integration Hz
Spec.Integrals_range = Spec.wz'*[1,1]/(2*pi)+[-1,1]*Spec.Integral_width/2  ;


data                 = zeros(length(Spec.vdd8), 2)                         ;  

for ivd = 1:length(Spec.vdd8)
    ivd
    Spec.d8        = Spec.vdd8(ivd)                                        ; % Mixing time
    Spec           = Spec.M.noesyph(Spec)                                  ; % Calculate EXSY sequence with phase cycling
    
    
    %% Plot 2D spectrum 
    Spec.lb        = 10                                                    ; % Linebroadening [Hz]
    Spec.lb1       = 10                                                    ; % Linebroadening [Hz]
    Spec           = Spec.M. proc_2D(Spec)                                 ; % Calculate spectrum    
    Spec.M. Plot_Spectrum2D(Spec)                                          ; % Plot spectrum
    
    %% analyze integrals
    Spec.Peaks             = Spec.wz/(2*pi)                                ; % This peaks we will integrate
    [Spec.Integrals]       = D2_integrals(Spec.frq,Spec.frq1,abs(Spec.Spectrum),Spec.Peaks,Spec.Integral_width)                                  ; % specify your integrations area
%     [kd, errorkd, kaprime] = kd_EXSY(Spec.d8,Spec.Integrals.rect(1,1),Spec.Integrals.rect(2,1),Spec.Integrals.rect(1,2),Spec.Integrals.rect(2,2)); % Calculate kd
%     data_int_diag(ivd,1)   = Spec.Integrals.rect(1,1) + Spec.Integrals.rect(2,2);
%     data_int_cross(ivd,1)  = Spec.Integrals.rect(1,2) + Spec.Integrals.rect(2,1);
%     data (ivd, 1)          = real (Spec.d8)                                ;
%     data (ivd, 2)          = real(kd)                                      ;
       
    [Spec.Int_noise]       = D2_integrals_noise(Spec.frq,Spec.frq1,abs(Spec.Spectrum),Spec.Peaks,40) ; % specify your integrations area
    data_int_noise(ivd,1)  = (Spec.Int_noise.rect(1,2) + Spec.Int_noise.rect(1,2))                   ;
     
    [kd, errorkd, kaprime] = kd_EXSY(Spec.d8,Spec.Integrals.rect(1,1),Spec.Integrals.rect(2,1),Spec.Integrals.rect(1,2),Spec.Integrals.rect(2,2)); % Calculate kd
    data_int_diag(ivd,1)   = (Spec.Integrals.rect(1,1) + Spec.Integrals.rect(2,2))- data_int_noise(ivd,1) ; % 
    data_int_cross(ivd,1)  = (Spec.Integrals.rect(1,2) + Spec.Integrals.rect(2,1))- data_int_noise(ivd,1) ; %
    data (ivd, 1)          = real (Spec.d8)                                ;
    data (ivd, 2)          = real(kd)                                      ;
    %% save
%     out       = Spec.Integrals.rect;
%     save(sprintf("out_EXSY_vd/EXSY_integrals_rect_dmix%.2fms.txt",[Spec.d8*1e3]),"out","-ASCII");
%     out       = [Spec.Integrals.range.lin Spec.Integrals.lin];
%     names     = ["dirL (Hz)","dirR (Hz)","indL (Hz)","indR (Hz)","integral"];
%     out       = [names',out']';
%     writematrix(out,sprintf("out_EXSY_vd/EXSY_integrals_lin_dmix%.2fms.txt",[Spec.d8*1e3]),'Delimiter','tab')
%     
%     % save all SEXY parameters
%     save(sprintf("out_EXSY_vd/EXSY_experiment_dmix%.2fms.txt",[Spec.d8*1e3]),"Spec")

end
%%
    figure("color","white")
    plot(data(:,1),data(:,2),"o")                                          ;
    ylabel("k_d (s^-^1)")
    xlabel("d_m_i_x (s)")

%%
    figure("color","white")
    plot(data(:,1),data_int_diag(:,1)/max(data_int_diag),data(:,1),data_int_cross(:,1)/max(data_int_diag),'--')  ;
    ylabel("Peaks amplitude (norm.)")
    xlabel("d_m_i_x (s)")

toc






