clear all
close all

tic

% parameters
fs               = 1000                                                    ; % Sampling frequency (Hz)
t                = 0:1/fs:1                                                ; % Time vector (1 second)
Freq_1           = 100                                                     ; % Frequency(Hz)
Freq_2           = 200                                                     ; % Frequency(Hz)
A_1              = 1                                                       ; 
A_2              = 2                                                       ;
ph0              = 0*pi/180                                              ; % zero order phase angle
ph1              = 0*pi/180                                              ; % first order phase angle
omega_1          = 2*pi*Freq_1                                             ; 
omega_2          = 2*pi*Freq_2                                             ;

T2               = 0.2                                                     ; % decay constant


% Generate the signal
x = A_1*exp(1i*omega_1*t).*exp(-t/T2)+ A_2*exp(1i*omega_2*t).*exp(-t/T2)   ; 
%x = x.*exp(1i*ph0)                                                         ; % applying only zero order phase correction

% Perform Fourrier 
% fourrier        = fftshift(fft(x))                                       ; % middle of fs
fourrier         = fft(x)                                                  ; % zero 

a = 0      + Freq_1                                                        ;
b = fs     + Freq_1                                                        ;

fourrier         = fourrier.*exp(-1i*(ph0 + ph1*(a:b)))                    ; % zero and first order phase correction 


% Plotting
figure("color","white",'DefaultAxesFontSize',14)

% subplot(2, 1, 1)
% plot(t, x)
% title('FID')
% xlabel('Time (s)')
% 
% subplot(2, 1, 2)
plot(real(fourrier))
title('Spectrum')
xlabel('Frequency (Hz)')
ylabel('Intensity (a.u.)')
xlim([0 400])

toc





