%% start %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; %clear all and delete all previous data
tic
p=LoadPath();
%% Load System %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
System=Load_SABRE_System_Name(1);
ex=Load_SABRE_System(System);

ex.Folder="out\onefield"+System;
%% Field parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ex.Bv=linspace(0.1,15,402)'*1e-6;   % delay/storage external magnetic field, T
%% calculate pulsed SABRE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rC0=DensityMatrix('100%_SingletSpinOrder',ex.Sc,1,2);
Yout = zeros(length(ex.Bv),length(ex.SOc));
    
for ib=1:length(ex.Bv)            
    B=ex.Bv(ib);
    H=2*pi*HZJij(ex.Sc,ex.ppmC,ex.JC,B,"full");
    [Q,E] = eig(full(H));
    rC=rC0.RemoveCoherences(Q);                
    Yout(ib,:)=real(Amplitudes(rC,ex.SOc));                    
end

% %% save data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% save_all_onefield(System,Yout{1}*100,ex);
out = [ex.Bv Yout];
save(ex.Folder+".dat","out","-ASCII");
 
%% rhos
figure("Color","white")
plot(ex.Bv,Yout*100,"LineWidth",2);
legend(ex.SOcStr);
xlabel("B (T)");
ylabel("Polarization (%)");
title("SABRE SHEATH ");
%%%%%%%%%%%%%%% end %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
